/* PulseAudioManager.c generated by valac 0.48.12, the Vala compiler
 * generated from PulseAudioManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016-2018 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */
/*
 * Vocabulary of PulseAudio:
 *  - Source: Input (microphone)
 *  - Sink: Output (speaker)
 */

#include <glib-object.h>
#include <pulse/pulseaudio.h>
#include <pulse/glib-mainloop.h>
#include <glib.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include "pulse/ext-stream-restore.h"

#define SOUND_TYPE_PULSE_AUDIO_MANAGER (sound_pulse_audio_manager_get_type ())
#define SOUND_PULSE_AUDIO_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager))
#define SOUND_PULSE_AUDIO_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManagerClass))
#define SOUND_IS_PULSE_AUDIO_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_TYPE_PULSE_AUDIO_MANAGER))
#define SOUND_IS_PULSE_AUDIO_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_TYPE_PULSE_AUDIO_MANAGER))
#define SOUND_PULSE_AUDIO_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManagerClass))

typedef struct _SoundPulseAudioManager SoundPulseAudioManager;
typedef struct _SoundPulseAudioManagerClass SoundPulseAudioManagerClass;
typedef struct _SoundPulseAudioManagerPrivate SoundPulseAudioManagerPrivate;

#define SOUND_TYPE_DEVICE (sound_device_get_type ())
#define SOUND_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_TYPE_DEVICE, SoundDevice))
#define SOUND_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_TYPE_DEVICE, SoundDeviceClass))
#define SOUND_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_TYPE_DEVICE))
#define SOUND_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_TYPE_DEVICE))
#define SOUND_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_TYPE_DEVICE, SoundDeviceClass))

typedef struct _SoundDevice SoundDevice;
typedef struct _SoundDeviceClass SoundDeviceClass;
enum  {
	SOUND_PULSE_AUDIO_MANAGER_0_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_NUM_PROPERTIES
};
static GParamSpec* sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_NUM_PROPERTIES];
#define _pa_context_unref0(var) ((var == NULL) ? NULL : (var = (pa_context_unref (var), NULL)))
#define _pa_glib_mainloop_free0(var) ((var == NULL) ? NULL : (var = (pa_glib_mainloop_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _SoundPulseAudioManagerSetDefaultDeviceData SoundPulseAudioManagerSetDefaultDeviceData;
typedef struct _Block1Data Block1Data;
#define _pa_operation_unref0(var) ((var == NULL) ? NULL : (var = (pa_operation_unref (var), NULL)))
typedef struct _SoundPulseAudioManagerSetCardProfileByIndexData SoundPulseAudioManagerSetCardProfileByIndexData;
typedef struct _Block2Data Block2Data;
typedef struct _SoundPulseAudioManagerWaitForUpdateData SoundPulseAudioManagerWaitForUpdateData;
typedef struct _Block3Data Block3Data;
typedef struct _SoundPulseAudioManagerSetSinkPortByNameData SoundPulseAudioManagerSetSinkPortByNameData;
typedef struct _Block4Data Block4Data;
typedef struct _SoundPulseAudioManagerSetSourcePortByNameData SoundPulseAudioManagerSetSourcePortByNameData;
typedef struct _Block5Data Block5Data;
typedef struct _SoundPulseAudioManagerSetDefaultSinkData SoundPulseAudioManagerSetDefaultSinkData;
typedef struct _Block6Data Block6Data;
typedef struct _SoundPulseAudioManagerSetDefaultSourceData SoundPulseAudioManagerSetDefaultSourceData;
typedef struct _Block7Data Block7Data;
typedef struct _SoundDevicePrivate SoundDevicePrivate;
#define _pa_proplist_free0(var) ((var == NULL) ? NULL : (var = (pa_proplist_free (var), NULL)))
typedef struct _SoundPulseAudioManagerReconnectToPulseData SoundPulseAudioManagerReconnectToPulseData;
typedef struct _Block8Data Block8Data;
typedef struct _Block9Data Block9Data;
enum  {
	SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL,
	SOUND_PULSE_AUDIO_MANAGER_NUM_SIGNALS
};
static guint sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NUM_SIGNALS] = {0};

struct _SoundPulseAudioManager {
	GObject parent_instance;
	SoundPulseAudioManagerPrivate * priv;
};

struct _SoundPulseAudioManagerClass {
	GObjectClass parent_class;
};

struct _SoundPulseAudioManagerPrivate {
	pa_context* _context;
	pa_glib_mainloop* loop;
	gboolean is_ready;
	guint reconnect_timer_id;
	GeeHashMap* input_devices;
	GeeHashMap* output_devices;
	SoundDevice* _default_output;
	SoundDevice* _default_input;
	gchar* default_source_name;
	gchar* default_sink_name;
	GeeHashMap* volume_operations;
};

struct _SoundPulseAudioManagerSetDefaultDeviceData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	SoundDevice* device;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	SoundDevice* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	SoundDevice* _tmp8_;
	SoundDevice* _tmp9_;
	SoundDevice* other_device;
	SoundDevice* _tmp10_;
	gchar* profile_name;
	SoundDevice* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	GeeArrayList* _tmp14_;
	GeeArrayList* _tmp15_;
	gpointer _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	guint32 _tmp23_;
	guint32 _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	gboolean _tmp27_;
	gboolean _tmp28_;
	gboolean _tmp29_;
	gboolean _tmp30_;
	gboolean _tmp31_;
	const gchar* _tmp32_;
	const gchar* _tmp33_;
	const gchar* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	const gchar* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	const gchar* _tmp43_;
	gboolean _tmp44_;
	gboolean _tmp45_;
	gboolean _tmp46_;
	const gchar* _tmp47_;
	const gchar* _tmp48_;
	const gchar* _tmp49_;
	const gchar* _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	const gchar* _tmp53_;
	const gchar* _tmp54_;
	const gchar* _tmp55_;
	const gchar* _tmp56_;
	const gchar* _tmp57_;
	const gchar* _tmp58_;
	gboolean _tmp59_;
	gboolean _tmp60_;
	gboolean _tmp61_;
	gboolean _tmp62_;
	const gchar* _tmp63_;
	const gchar* _tmp64_;
	gboolean _tmp65_;
	gboolean _tmp66_;
	gboolean _tmp67_;
	const gchar* _tmp68_;
	const gchar* _tmp69_;
	const gchar* _tmp70_;
	gboolean _tmp71_;
	gboolean _tmp72_;
	gboolean _tmp73_;
	gboolean _tmp74_;
	gboolean _tmp75_;
	const gchar* _tmp76_;
	const gchar* _tmp77_;
	const gchar* _tmp78_;
	const gchar* _tmp79_;
	const gchar* _tmp80_;
	const gchar* _tmp81_;
	const gchar* _tmp82_;
	const gchar* _tmp83_;
	gboolean _tmp84_;
	gboolean _tmp85_;
	gboolean _tmp86_;
	const gchar* _tmp87_;
	const gchar* _tmp88_;
	const gchar* _tmp89_;
	const gchar* _tmp90_;
	const gchar* _tmp91_;
	const gchar* _tmp92_;
	const gchar* _tmp93_;
	const gchar* _tmp94_;
};

struct _Block1Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	guint32 card_index;
	gchar* profile_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerSetCardProfileByIndexData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	guint32 card_index;
	gchar* profile_name;
	Block1Data* _data1_;
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
};

struct _Block2Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	gulong handler_id;
	SoundDevice* device;
	gchar* prop_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerWaitForUpdateData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	SoundDevice* device;
	gchar* prop_name;
	Block2Data* _data2_;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gulong _tmp3_;
};

struct _Block3Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	gchar* sink_name;
	gchar* port_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerSetSinkPortByNameData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	gchar* sink_name;
	gchar* port_name;
	Block3Data* _data3_;
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
};

struct _Block4Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	gchar* source_name;
	gchar* port_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerSetSourcePortByNameData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	gchar* source_name;
	gchar* port_name;
	Block4Data* _data4_;
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
};

struct _Block5Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	gchar* sink_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerSetDefaultSinkData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	gchar* sink_name;
	Block5Data* _data5_;
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
};

struct _Block6Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	gchar* source_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerSetDefaultSourceData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	gchar* source_name;
	Block6Data* _data6_;
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
};

struct _Block7Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	SoundDevice* device;
};

struct _SoundDevice {
	GObject parent_instance;
	SoundDevicePrivate * priv;
	pa_cvolume cvolume;
	pa_channel_map channel_map;
	GeeLinkedList* volume_operations;
};

struct _SoundDeviceClass {
	GObjectClass parent_class;
};

struct _SoundPulseAudioManagerReconnectToPulseData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	pa_context* _tmp0_;
	pa_proplist* props;
	pa_proplist* _tmp1_;
	pa_proplist* _tmp2_;
	pa_glib_mainloop* _tmp3_;
	pa_mainloop_api* _tmp4_;
	pa_proplist* _tmp5_;
	pa_context* _tmp6_;
	pa_context* _tmp7_;
	pa_context* _tmp8_;
	pa_context* _tmp9_;
	pa_context* _tmp10_;
	const gchar* _tmp11_;
};

struct _Block8Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	SoundDevice* device;
};

struct _Block9Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	SoundDevice* device;
};

static gint SoundPulseAudioManager_private_offset;
static gpointer sound_pulse_audio_manager_parent_class = NULL;
static SoundPulseAudioManager* sound_pulse_audio_manager_pam;
static SoundPulseAudioManager* sound_pulse_audio_manager_pam = NULL;
static gboolean sound_pulse_audio_manager_debug_enabled;
static gboolean sound_pulse_audio_manager_debug_enabled = FALSE;

GType sound_pulse_audio_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SoundPulseAudioManager, g_object_unref)
GType sound_device_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SoundDevice, g_object_unref)
SoundPulseAudioManager* sound_pulse_audio_manager_get_default (void);
static SoundPulseAudioManager* sound_pulse_audio_manager_new (void);
static SoundPulseAudioManager* sound_pulse_audio_manager_construct (GType object_type);
void sound_pulse_audio_manager_start (SoundPulseAudioManager* self);
static void sound_pulse_audio_manager_reconnect_to_pulse (SoundPulseAudioManager* self,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
static void sound_pulse_audio_manager_reconnect_to_pulse_finish (SoundPulseAudioManager* self,
                                                          GAsyncResult* _res_);
static void sound_pulse_audio_manager_set_default_device_data_free (gpointer _data);
void sound_pulse_audio_manager_set_default_device (SoundPulseAudioManager* self,
                                                   SoundDevice* device,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
void sound_pulse_audio_manager_set_default_device_finish (SoundPulseAudioManager* self,
                                                          GAsyncResult* _res_);
static gboolean sound_pulse_audio_manager_set_default_device_co (SoundPulseAudioManagerSetDefaultDeviceData* _data_);
const gchar* sound_device_get_id (SoundDevice* self);
gboolean sound_device_get_input (SoundDevice* self);
SoundDevice* sound_pulse_audio_manager_get_default_output (SoundPulseAudioManager* self);
SoundDevice* sound_pulse_audio_manager_get_default_input (SoundPulseAudioManager* self);
gchar* sound_device_get_matching_profile (SoundDevice* self,
                                          SoundDevice* other_device);
GeeArrayList* sound_device_get_profiles (SoundDevice* self);
const gchar* sound_device_get_card_active_profile_name (SoundDevice* self);
static void sound_pulse_audio_manager_set_card_profile_by_index (SoundPulseAudioManager* self,
                                                          guint32 card_index,
                                                          const gchar* profile_name,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_);
static void sound_pulse_audio_manager_set_card_profile_by_index_finish (SoundPulseAudioManager* self,
                                                                 GAsyncResult* _res_);
guint32 sound_device_get_card_index (SoundDevice* self);
static void sound_pulse_audio_manager_set_default_device_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_);
static void sound_pulse_audio_manager_wait_for_update (SoundPulseAudioManager* self,
                                                SoundDevice* device,
                                                const gchar* prop_name,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
static void sound_pulse_audio_manager_wait_for_update_finish (SoundPulseAudioManager* self,
                                                       GAsyncResult* _res_);
const gchar* sound_device_get_port_name (SoundDevice* self);
const gchar* sound_device_get_card_sink_port_name (SoundDevice* self);
static void sound_pulse_audio_manager_set_sink_port_by_name (SoundPulseAudioManager* self,
                                                      const gchar* sink_name,
                                                      const gchar* port_name,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_);
static void sound_pulse_audio_manager_set_sink_port_by_name_finish (SoundPulseAudioManager* self,
                                                             GAsyncResult* _res_);
const gchar* sound_device_get_card_sink_name (SoundDevice* self);
const gchar* sound_device_get_card_source_port_name (SoundDevice* self);
static void sound_pulse_audio_manager_set_source_port_by_name (SoundPulseAudioManager* self,
                                                        const gchar* source_name,
                                                        const gchar* port_name,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_);
static void sound_pulse_audio_manager_set_source_port_by_name_finish (SoundPulseAudioManager* self,
                                                               GAsyncResult* _res_);
const gchar* sound_device_get_card_source_name (SoundDevice* self);
const gchar* sound_device_get_sink_name (SoundDevice* self);
const gchar* sound_device_get_source_name (SoundDevice* self);
static void sound_pulse_audio_manager_set_default_sink (SoundPulseAudioManager* self,
                                                 const gchar* sink_name,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
static void sound_pulse_audio_manager_set_default_sink_finish (SoundPulseAudioManager* self,
                                                        GAsyncResult* _res_);
static void sound_pulse_audio_manager_set_default_source (SoundPulseAudioManager* self,
                                                   const gchar* source_name,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
static void sound_pulse_audio_manager_set_default_source_finish (SoundPulseAudioManager* self,
                                                          GAsyncResult* _res_);
static void sound_pulse_audio_manager_set_card_profile_by_index_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_set_card_profile_by_index_co (SoundPulseAudioManagerSetCardProfileByIndexData* _data_);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
pa_context* sound_pulse_audio_manager_get_context (SoundPulseAudioManager* self);
static void __lambda9_ (Block1Data* _data1_,
                 pa_context* c,
                 gint success);
static void ___lambda9__pa_context_success_cb_t (pa_context* c,
                                          gint success,
                                          gpointer self);
static void sound_pulse_audio_manager_wait_for_update_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_wait_for_update_co (SoundPulseAudioManagerWaitForUpdateData* _data_);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda10_ (Block2Data* _data2_,
                  GObject* s,
                  GParamSpec* p);
static void ___lambda10__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void sound_pulse_audio_manager_set_sink_port_by_name_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_set_sink_port_by_name_co (SoundPulseAudioManagerSetSinkPortByNameData* _data_);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda11_ (Block3Data* _data3_,
                  pa_context* c,
                  gint success);
static void ___lambda11__pa_context_success_cb_t (pa_context* c,
                                           gint success,
                                           gpointer self);
static void sound_pulse_audio_manager_set_source_port_by_name_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_set_source_port_by_name_co (SoundPulseAudioManagerSetSourcePortByNameData* _data_);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda12_ (Block4Data* _data4_,
                  pa_context* c,
                  gint success);
static void ___lambda12__pa_context_success_cb_t (pa_context* c,
                                           gint success,
                                           gpointer self);
static void sound_pulse_audio_manager_set_default_sink_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_set_default_sink_co (SoundPulseAudioManagerSetDefaultSinkData* _data_);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void __lambda13_ (Block5Data* _data5_,
                  pa_context* c,
                  gint success);
static void ___lambda13__pa_context_success_cb_t (pa_context* c,
                                           gint success,
                                           gpointer self);
static void sound_pulse_audio_manager_set_default_source_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_set_default_source_co (SoundPulseAudioManagerSetDefaultSourceData* _data_);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void __lambda14_ (Block6Data* _data6_,
                  pa_context* c,
                  gint success);
static void ___lambda14__pa_context_success_cb_t (pa_context* c,
                                           gint success,
                                           gpointer self);
void sound_pulse_audio_manager_change_device_mute (SoundPulseAudioManager* self,
                                                   SoundDevice* device,
                                                   gboolean mute);
void sound_pulse_audio_manager_change_device_volume (SoundPulseAudioManager* self,
                                                     SoundDevice* device,
                                                     gdouble volume);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static gboolean __lambda15_ (Block7Data* _data7_,
                      pa_operation* operation);
static gboolean ___lambda15__gee_forall_func (gpointer g,
                                       gpointer self);
static pa_volume_t sound_pulse_audio_manager_double_to_volume (gdouble vol);
void sound_pulse_audio_manager_change_device_balance (SoundPulseAudioManager* self,
                                                      SoundDevice* device,
                                                      gfloat balance);
static gboolean sound_pulse_audio_manager_reconnect_timeout (SoundPulseAudioManager* self);
static void sound_pulse_audio_manager_reconnect_to_pulse_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_reconnect_to_pulse_co (SoundPulseAudioManagerReconnectToPulseData* _data_);
static void sound_pulse_audio_manager_set_context (SoundPulseAudioManager* self,
                                            pa_context* value);
static void sound_pulse_audio_manager_context_state_callback (SoundPulseAudioManager* self,
                                                       pa_context* c);
static void _sound_pulse_audio_manager_context_state_callback_pa_context_notify_cb_t (pa_context* c,
                                                                               gpointer self);
static void sound_pulse_audio_manager_subscribe_callback (SoundPulseAudioManager* self,
                                                   pa_context* c,
                                                   pa_subscription_event_type_t t,
                                                   guint32 index);
static void _sound_pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t (pa_context* c,
                                                                              pa_subscription_event_type_t t,
                                                                              guint32 idx,
                                                                              gpointer self);
static void sound_pulse_audio_manager_server_info_callback (SoundPulseAudioManager* self,
                                                     pa_context* context,
                                                     pa_server_info* server);
static void _sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t (pa_context* c,
                                                                          pa_server_info* i,
                                                                          gpointer self);
static gboolean _sound_pulse_audio_manager_reconnect_timeout_gsource_func (gpointer self);
static void sound_pulse_audio_manager_sink_info_callback (SoundPulseAudioManager* self,
                                                   pa_context* c,
                                                   pa_sink_info* sink,
                                                   gint eol);
static void _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t (pa_context* c,
                                                                      pa_sink_info* i,
                                                                      gint eol,
                                                                      gpointer self);
gint sound_device_get_sink_index (SoundDevice* self);
void sound_device_set_sink_name (SoundDevice* self,
                                 const gchar* value);
void sound_device_set_sink_index (SoundDevice* self,
                                  gint value);
void sound_device_set_is_default (SoundDevice* self,
                                  gboolean value);
gint sound_device_get_card_sink_index (SoundDevice* self);
void sound_device_set_card_sink_name (SoundDevice* self,
                                      const gchar* value);
void sound_device_set_card_sink_index (SoundDevice* self,
                                       gint value);
void sound_device_set_card_sink_port_name (SoundDevice* self,
                                           const gchar* value);
static void sound_pulse_audio_manager_card_info_callback (SoundPulseAudioManager* self,
                                                   pa_context* c,
                                                   pa_card_info* card,
                                                   gint eol);
static void _sound_pulse_audio_manager_card_info_callback_pa_card_info_cb_t (pa_context* c,
                                                                      pa_card_info* i,
                                                                      gint eol,
                                                                      gpointer self);
static void sound_pulse_audio_manager_remove_devices_by_card (SoundPulseAudioManager* self,
                                                       GeeHashMap* devices,
                                                       guint32 card_index);
static void sound_pulse_audio_manager_source_info_callback (SoundPulseAudioManager* self,
                                                     pa_context* c,
                                                     pa_source_info* source,
                                                     gint eol);
static void _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t (pa_context* c,
                                                                          pa_source_info* i,
                                                                          gint eol,
                                                                          gpointer self);
gint sound_device_get_source_index (SoundDevice* self);
void sound_device_set_source_name (SoundDevice* self,
                                   const gchar* value);
void sound_device_set_source_index (SoundDevice* self,
                                    gint value);
gint sound_device_get_card_source_index (SoundDevice* self);
void sound_device_set_card_source_name (SoundDevice* self,
                                        const gchar* value);
void sound_device_set_card_source_index (SoundDevice* self,
                                         gint value);
void sound_device_set_card_source_port_name (SoundDevice* self,
                                             const gchar* value);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
gboolean sound_device_get_is_default (SoundDevice* self);
void sound_device_set_is_muted (SoundDevice* self,
                                gboolean value);
void sound_device_set_balance (SoundDevice* self,
                               gfloat value);
static gboolean ______lambda8_ (Block8Data* _data8_,
                         pa_operation* operation);
static gboolean _______lambda8__gee_forall_func (gpointer g,
                                          gpointer self);
static gdouble sound_pulse_audio_manager_volume_to_double (pa_volume_t vol);
void sound_device_set_volume (SoundDevice* self,
                              gdouble value);
static void sound_pulse_audio_manager_set_default_input (SoundPulseAudioManager* self,
                                                  SoundDevice* value);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static gboolean ______lambda5_ (Block9Data* _data9_,
                         pa_operation* operation);
static gboolean _______lambda5__gee_forall_func (gpointer g,
                                          gpointer self);
static void sound_pulse_audio_manager_set_default_output (SoundPulseAudioManager* self,
                                                   SoundDevice* value);
static void _vala_array_add1 (pa_card_port_info** * array,
                       gint* length,
                       gint* size,
                       pa_card_port_info* value);
static gchar* sound_pulse_audio_manager_get_device_id (pa_card_info* card,
                                                pa_card_port_info* port);
SoundDevice* sound_device_new (const gchar* id,
                               guint32 card_index,
                               const gchar* port_name);
SoundDevice* sound_device_construct (GType object_type,
                                     const gchar* id,
                                     guint32 card_index,
                                     const gchar* port_name);
void sound_device_set_card_active_profile_name (SoundDevice* self,
                                                const gchar* value);
void sound_device_set_input (SoundDevice* self,
                             gboolean value);
void sound_device_set_card_name (SoundDevice* self,
                                 const gchar* value);
void sound_device_set_display_name (SoundDevice* self,
                                    const gchar* value);
void sound_device_set_form_factor (SoundDevice* self,
                                   const gchar* value);
static GeeArrayList* sound_pulse_audio_manager_get_relevant_card_port_profiles (SoundPulseAudioManager* self,
                                                                         pa_card_port_info* port);
void sound_device_set_profiles (SoundDevice* self,
                                GeeArrayList* value);
static void sound_pulse_audio_manager_cleanup_devices (SoundPulseAudioManager* self,
                                                GeeHashMap* devices,
                                                pa_card_info* card,
                                                pa_card_port_info** relevant_ports,
                                                gint relevant_ports_length1);
static pa_card_profile_info2** _vala_array_dup1 (pa_card_profile_info2** self,
                                          gint length);
static gint __lambda7_ (SoundPulseAudioManager* self,
                 pa_card_profile_info2* a,
                 pa_card_profile_info2* b);
static gint ___lambda7__gcompare_data_func (gconstpointer a,
                                     gconstpointer b,
                                     gpointer self);
static void sound_pulse_audio_manager_ext_stream_restore_read_sink_callback (SoundPulseAudioManager* self,
                                                                      pa_context* c,
                                                                      pa_ext_stream_restore_info* info,
                                                                      gint eol);
static void _sound_pulse_audio_manager_ext_stream_restore_read_sink_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                              pa_ext_stream_restore_info* info,
                                                                                                              gint eol,
                                                                                                              gpointer self);
static void sound_pulse_audio_manager_ext_stream_restore_read_source_callback (SoundPulseAudioManager* self,
                                                                        pa_context* c,
                                                                        pa_ext_stream_restore_info* info,
                                                                        gint eol);
static void _sound_pulse_audio_manager_ext_stream_restore_read_source_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                                pa_ext_stream_restore_info* info,
                                                                                                                gint eol,
                                                                                                                gpointer self);
static void __lambda6_ (SoundPulseAudioManager* self,
                 pa_context* c,
                 gint success);
static void ___lambda6__pa_context_success_cb_t (pa_context* c,
                                          gint success,
                                          gpointer self);
static GObject * sound_pulse_audio_manager_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gint stack_length,
                                      const gchar* needle);
static void sound_pulse_audio_manager_finalize (GObject * obj);
static GType sound_pulse_audio_manager_get_type_once (void);
static void _vala_sound_pulse_audio_manager_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_sound_pulse_audio_manager_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
sound_pulse_audio_manager_get_instance_private (SoundPulseAudioManager* self)
{
	return G_STRUCT_MEMBER_P (self, SoundPulseAudioManager_private_offset);
}

SoundPulseAudioManager*
sound_pulse_audio_manager_get_default (void)
{
	SoundPulseAudioManager* _tmp0_;
	SoundPulseAudioManager* _tmp2_;
	SoundPulseAudioManager* result = NULL;
	_tmp0_ = sound_pulse_audio_manager_pam;
	if (_tmp0_ == NULL) {
		SoundPulseAudioManager* _tmp1_;
		_tmp1_ = sound_pulse_audio_manager_new ();
		_g_object_unref0 (sound_pulse_audio_manager_pam);
		sound_pulse_audio_manager_pam = _tmp1_;
	}
	_tmp2_ = sound_pulse_audio_manager_pam;
	result = _tmp2_;
	return result;
}

static SoundPulseAudioManager*
sound_pulse_audio_manager_construct (GType object_type)
{
	SoundPulseAudioManager * self = NULL;
	self = (SoundPulseAudioManager*) g_object_new (object_type, NULL);
	return self;
}

static SoundPulseAudioManager*
sound_pulse_audio_manager_new (void)
{
	return sound_pulse_audio_manager_construct (SOUND_TYPE_PULSE_AUDIO_MANAGER);
}

void
sound_pulse_audio_manager_start (SoundPulseAudioManager* self)
{
	g_return_if_fail (self != NULL);
	sound_pulse_audio_manager_reconnect_to_pulse (self, NULL, NULL);
}

static void
sound_pulse_audio_manager_set_default_device_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetDefaultDeviceData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->device);
	_g_object_unref0 (_data_->self);
	g_slice_free (SoundPulseAudioManagerSetDefaultDeviceData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
sound_pulse_audio_manager_set_default_device (SoundPulseAudioManager* self,
                                              SoundDevice* device,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	SoundPulseAudioManagerSetDefaultDeviceData* _data_;
	SoundPulseAudioManager* _tmp0_;
	SoundDevice* _tmp1_;
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetDefaultDeviceData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_default_device_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (device);
	_g_object_unref0 (_data_->device);
	_data_->device = _tmp1_;
	sound_pulse_audio_manager_set_default_device_co (_data_);
}

void
sound_pulse_audio_manager_set_default_device_finish (SoundPulseAudioManager* self,
                                                     GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetDefaultDeviceData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
sound_pulse_audio_manager_set_default_device_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_)
{
	SoundPulseAudioManagerSetDefaultDeviceData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	sound_pulse_audio_manager_set_default_device_co (_data_);
}

static gboolean
sound_pulse_audio_manager_set_default_device_co (SoundPulseAudioManagerSetDefaultDeviceData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		case 3:
		goto _state_3;
		case 4:
		goto _state_4;
		case 5:
		goto _state_5;
		case 6:
		goto _state_6;
		case 7:
		goto _state_7;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	g_debug ("PulseAudioManager.vala:77: \n");
	_data_->_tmp0_ = sound_device_get_id (_data_->device);
	_data_->_tmp1_ = _data_->_tmp0_;
	g_debug ("PulseAudioManager.vala:78: set_default_device: %s", _data_->_tmp1_);
	_data_->_tmp3_ = sound_device_get_input (_data_->device);
	_data_->_tmp4_ = _data_->_tmp3_;
	if (_data_->_tmp4_) {
		_data_->_tmp2_ = "input";
	} else {
		_data_->_tmp2_ = "output";
	}
	g_debug ("PulseAudioManager.vala:79: \t%s", _data_->_tmp2_);
	_data_->_tmp6_ = sound_device_get_input (_data_->device);
	_data_->_tmp7_ = _data_->_tmp6_;
	if (_data_->_tmp7_) {
		_data_->_tmp8_ = _data_->self->priv->_default_output;
		_data_->_tmp5_ = _data_->_tmp8_;
	} else {
		_data_->_tmp9_ = _data_->self->priv->_default_input;
		_data_->_tmp5_ = _data_->_tmp9_;
	}
	_data_->_tmp10_ = _g_object_ref0 (_data_->_tmp5_);
	_data_->other_device = _data_->_tmp10_;
	_data_->_tmp11_ = _data_->other_device;
	_data_->_tmp12_ = sound_device_get_matching_profile (_data_->device, _data_->_tmp11_);
	_data_->profile_name = _data_->_tmp12_;
	_data_->_tmp13_ = _data_->profile_name;
	if (_data_->_tmp13_ == NULL) {
		_data_->_tmp14_ = sound_device_get_profiles (_data_->device);
		_data_->_tmp15_ = _data_->_tmp14_;
		_data_->_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp15_, 0);
		_g_free0 (_data_->profile_name);
		_data_->profile_name = (gchar*) _data_->_tmp16_;
	}
	_data_->_tmp17_ = _data_->profile_name;
	_data_->_tmp18_ = sound_device_get_card_active_profile_name (_data_->device);
	_data_->_tmp19_ = _data_->_tmp18_;
	if (g_strcmp0 (_data_->_tmp17_, _data_->_tmp19_) != 0) {
		_data_->_tmp20_ = sound_device_get_card_active_profile_name (_data_->device);
		_data_->_tmp21_ = _data_->_tmp20_;
		_data_->_tmp22_ = _data_->profile_name;
		g_debug ("PulseAudioManager.vala:94: set card profile: %s > %s", _data_->_tmp21_, _data_->_tmp22_);
		_data_->_tmp23_ = sound_device_get_card_index (_data_->device);
		_data_->_tmp24_ = _data_->_tmp23_;
		_data_->_tmp25_ = _data_->profile_name;
		_data_->_state_ = 1;
		sound_pulse_audio_manager_set_card_profile_by_index (_data_->self, _data_->_tmp24_, _data_->_tmp25_, sound_pulse_audio_manager_set_default_device_ready, _data_);
		return FALSE;
		_state_1:
		sound_pulse_audio_manager_set_card_profile_by_index_finish (_data_->self, _data_->_res_);
		g_debug ("PulseAudioManager.vala:98: wait for card sink / source");
		_data_->_tmp27_ = sound_device_get_input (_data_->device);
		_data_->_tmp28_ = _data_->_tmp27_;
		if (_data_->_tmp28_) {
			_data_->_tmp26_ = "card-source-name";
		} else {
			_data_->_tmp26_ = "card-sink-name";
		}
		_data_->_state_ = 2;
		sound_pulse_audio_manager_wait_for_update (_data_->self, _data_->device, _data_->_tmp26_, sound_pulse_audio_manager_set_default_device_ready, _data_);
		return FALSE;
		_state_2:
		sound_pulse_audio_manager_wait_for_update_finish (_data_->self, _data_->_res_);
	}
	_data_->_tmp30_ = sound_device_get_input (_data_->device);
	_data_->_tmp31_ = _data_->_tmp30_;
	if (!_data_->_tmp31_) {
		_data_->_tmp32_ = sound_device_get_port_name (_data_->device);
		_data_->_tmp33_ = _data_->_tmp32_;
		_data_->_tmp34_ = sound_device_get_card_sink_port_name (_data_->device);
		_data_->_tmp35_ = _data_->_tmp34_;
		_data_->_tmp29_ = g_strcmp0 (_data_->_tmp33_, _data_->_tmp35_) != 0;
	} else {
		_data_->_tmp29_ = FALSE;
	}
	if (_data_->_tmp29_) {
		_data_->_tmp36_ = sound_device_get_card_sink_port_name (_data_->device);
		_data_->_tmp37_ = _data_->_tmp36_;
		_data_->_tmp38_ = sound_device_get_port_name (_data_->device);
		_data_->_tmp39_ = _data_->_tmp38_;
		g_debug ("PulseAudioManager.vala:105: set sink port: %s > %s", _data_->_tmp37_, _data_->_tmp39_);
		_data_->_tmp40_ = sound_device_get_card_sink_name (_data_->device);
		_data_->_tmp41_ = _data_->_tmp40_;
		_data_->_tmp42_ = sound_device_get_port_name (_data_->device);
		_data_->_tmp43_ = _data_->_tmp42_;
		_data_->_state_ = 3;
		sound_pulse_audio_manager_set_sink_port_by_name (_data_->self, _data_->_tmp41_, _data_->_tmp43_, sound_pulse_audio_manager_set_default_device_ready, _data_);
		return FALSE;
		_state_3:
		sound_pulse_audio_manager_set_sink_port_by_name_finish (_data_->self, _data_->_res_);
	}
	_data_->_tmp45_ = sound_device_get_input (_data_->device);
	_data_->_tmp46_ = _data_->_tmp45_;
	if (_data_->_tmp46_) {
		_data_->_tmp47_ = sound_device_get_port_name (_data_->device);
		_data_->_tmp48_ = _data_->_tmp47_;
		_data_->_tmp49_ = sound_device_get_card_source_port_name (_data_->device);
		_data_->_tmp50_ = _data_->_tmp49_;
		_data_->_tmp44_ = g_strcmp0 (_data_->_tmp48_, _data_->_tmp50_) != 0;
	} else {
		_data_->_tmp44_ = FALSE;
	}
	if (_data_->_tmp44_) {
		_data_->_tmp51_ = sound_device_get_card_source_port_name (_data_->device);
		_data_->_tmp52_ = _data_->_tmp51_;
		_data_->_tmp53_ = sound_device_get_port_name (_data_->device);
		_data_->_tmp54_ = _data_->_tmp53_;
		g_debug ("PulseAudioManager.vala:111: set source port: %s > %s", _data_->_tmp52_, _data_->_tmp54_);
		_data_->_tmp55_ = sound_device_get_card_source_name (_data_->device);
		_data_->_tmp56_ = _data_->_tmp55_;
		_data_->_tmp57_ = sound_device_get_port_name (_data_->device);
		_data_->_tmp58_ = _data_->_tmp57_;
		_data_->_state_ = 4;
		sound_pulse_audio_manager_set_source_port_by_name (_data_->self, _data_->_tmp56_, _data_->_tmp58_, sound_pulse_audio_manager_set_default_device_ready, _data_);
		return FALSE;
		_state_4:
		sound_pulse_audio_manager_set_source_port_by_name_finish (_data_->self, _data_->_res_);
	}
	_data_->_tmp61_ = sound_device_get_input (_data_->device);
	_data_->_tmp62_ = _data_->_tmp61_;
	if (!_data_->_tmp62_) {
		_data_->_tmp63_ = sound_device_get_sink_name (_data_->device);
		_data_->_tmp64_ = _data_->_tmp63_;
		_data_->_tmp60_ = _data_->_tmp64_ == NULL;
	} else {
		_data_->_tmp60_ = FALSE;
	}
	if (_data_->_tmp60_) {
		_data_->_tmp59_ = TRUE;
	} else {
		_data_->_tmp66_ = sound_device_get_input (_data_->device);
		_data_->_tmp67_ = _data_->_tmp66_;
		if (_data_->_tmp67_) {
			_data_->_tmp68_ = sound_device_get_source_name (_data_->device);
			_data_->_tmp69_ = _data_->_tmp68_;
			_data_->_tmp65_ = _data_->_tmp69_ == NULL;
		} else {
			_data_->_tmp65_ = FALSE;
		}
		_data_->_tmp59_ = _data_->_tmp65_;
	}
	if (_data_->_tmp59_) {
		g_debug ("PulseAudioManager.vala:118: wait for sink / source");
		_data_->_tmp71_ = sound_device_get_input (_data_->device);
		_data_->_tmp72_ = _data_->_tmp71_;
		if (_data_->_tmp72_) {
			_data_->_tmp70_ = "source-name";
		} else {
			_data_->_tmp70_ = "sink-name";
		}
		_data_->_state_ = 5;
		sound_pulse_audio_manager_wait_for_update (_data_->self, _data_->device, _data_->_tmp70_, sound_pulse_audio_manager_set_default_device_ready, _data_);
		return FALSE;
		_state_5:
		sound_pulse_audio_manager_wait_for_update_finish (_data_->self, _data_->_res_);
	}
	_data_->_tmp74_ = sound_device_get_input (_data_->device);
	_data_->_tmp75_ = _data_->_tmp74_;
	if (!_data_->_tmp75_) {
		_data_->_tmp76_ = sound_device_get_sink_name (_data_->device);
		_data_->_tmp77_ = _data_->_tmp76_;
		_data_->_tmp78_ = _data_->self->priv->default_sink_name;
		_data_->_tmp73_ = g_strcmp0 (_data_->_tmp77_, _data_->_tmp78_) != 0;
	} else {
		_data_->_tmp73_ = FALSE;
	}
	if (_data_->_tmp73_) {
		_data_->_tmp79_ = _data_->self->priv->default_sink_name;
		_data_->_tmp80_ = sound_device_get_sink_name (_data_->device);
		_data_->_tmp81_ = _data_->_tmp80_;
		g_debug ("PulseAudioManager.vala:125: set sink: %s > %s", _data_->_tmp79_, _data_->_tmp81_);
		_data_->_tmp82_ = sound_device_get_sink_name (_data_->device);
		_data_->_tmp83_ = _data_->_tmp82_;
		_data_->_state_ = 6;
		sound_pulse_audio_manager_set_default_sink (_data_->self, _data_->_tmp83_, sound_pulse_audio_manager_set_default_device_ready, _data_);
		return FALSE;
		_state_6:
		sound_pulse_audio_manager_set_default_sink_finish (_data_->self, _data_->_res_);
	}
	_data_->_tmp85_ = sound_device_get_input (_data_->device);
	_data_->_tmp86_ = _data_->_tmp85_;
	if (_data_->_tmp86_) {
		_data_->_tmp87_ = sound_device_get_source_name (_data_->device);
		_data_->_tmp88_ = _data_->_tmp87_;
		_data_->_tmp89_ = _data_->self->priv->default_source_name;
		_data_->_tmp84_ = g_strcmp0 (_data_->_tmp88_, _data_->_tmp89_) != 0;
	} else {
		_data_->_tmp84_ = FALSE;
	}
	if (_data_->_tmp84_) {
		_data_->_tmp90_ = _data_->self->priv->default_source_name;
		_data_->_tmp91_ = sound_device_get_source_name (_data_->device);
		_data_->_tmp92_ = _data_->_tmp91_;
		g_debug ("PulseAudioManager.vala:130: set source: %s > %s", _data_->_tmp90_, _data_->_tmp92_);
		_data_->_tmp93_ = sound_device_get_source_name (_data_->device);
		_data_->_tmp94_ = _data_->_tmp93_;
		_data_->_state_ = 7;
		sound_pulse_audio_manager_set_default_source (_data_->self, _data_->_tmp94_, sound_pulse_audio_manager_set_default_device_ready, _data_);
		return FALSE;
		_state_7:
		sound_pulse_audio_manager_set_default_source_finish (_data_->self, _data_->_res_);
	}
	_g_free0 (_data_->profile_name);
	_g_object_unref0 (_data_->other_device);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
sound_pulse_audio_manager_set_card_profile_by_index_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetCardProfileByIndexData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (SoundPulseAudioManagerSetCardProfileByIndexData, _data_);
}

static void
sound_pulse_audio_manager_set_card_profile_by_index (SoundPulseAudioManager* self,
                                                     guint32 card_index,
                                                     const gchar* profile_name,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	SoundPulseAudioManagerSetCardProfileByIndexData* _data_;
	SoundPulseAudioManager* _tmp0_;
	gchar* _tmp1_;
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetCardProfileByIndexData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_card_profile_by_index_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_data_->card_index = card_index;
	_tmp1_ = g_strdup (profile_name);
	_g_free0 (_data_->profile_name);
	_data_->profile_name = _tmp1_;
	sound_pulse_audio_manager_set_card_profile_by_index_co (_data_);
}

static void
sound_pulse_audio_manager_set_card_profile_by_index_finish (SoundPulseAudioManager* self,
                                                            GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetCardProfileByIndexData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		SoundPulseAudioManager* self;
		self = _data1_->self;
		_g_free0 (_data1_->profile_name);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static void
__lambda9_ (Block1Data* _data1_,
            pa_context* c,
            gint success)
{
	SoundPulseAudioManager* self;
	self = _data1_->self;
	g_return_if_fail (c != NULL);
	if (success == 1) {
		sound_pulse_audio_manager_set_card_profile_by_index_co (_data1_->_async_data_);
	} else {
		g_warning ("PulseAudioManager.vala:140: setting card %u profile to %s failed", (guint) _data1_->card_index, _data1_->profile_name);
	}
}

static void
___lambda9__pa_context_success_cb_t (pa_context* c,
                                     gint success,
                                     gpointer self)
{
	__lambda9_ (self, c, success);
}

static gboolean
sound_pulse_audio_manager_set_card_profile_by_index_co (SoundPulseAudioManagerSetCardProfileByIndexData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data1_ = g_slice_new0 (Block1Data);
	_data_->_data1_->_ref_count_ = 1;
	_data_->_data1_->self = g_object_ref (_data_->self);
	_data_->_data1_->card_index = _data_->card_index;
	_g_free0 (_data_->_data1_->profile_name);
	_data_->_data1_->profile_name = _data_->profile_name;
	_data_->_data1_->_async_data_ = _data_;
	_data_->_tmp0_ = _data_->self->priv->_context;
	_data_->_tmp1_ = pa_context_set_card_profile_by_index (_data_->_tmp0_, _data_->_data1_->card_index, _data_->_data1_->profile_name, ___lambda9__pa_context_success_cb_t, _data_->_data1_);
	_data_->_tmp2_ = _data_->_tmp1_;
	_pa_operation_unref0 (_data_->_tmp2_);
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	block1_data_unref (_data_->_data1_);
	_data_->_data1_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
sound_pulse_audio_manager_wait_for_update_data_free (gpointer _data)
{
	SoundPulseAudioManagerWaitForUpdateData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (SoundPulseAudioManagerWaitForUpdateData, _data_);
}

static void
sound_pulse_audio_manager_wait_for_update (SoundPulseAudioManager* self,
                                           SoundDevice* device,
                                           const gchar* prop_name,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	SoundPulseAudioManagerWaitForUpdateData* _data_;
	SoundPulseAudioManager* _tmp0_;
	SoundDevice* _tmp1_;
	gchar* _tmp2_;
	_data_ = g_slice_new0 (SoundPulseAudioManagerWaitForUpdateData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_wait_for_update_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (device);
	_g_object_unref0 (_data_->device);
	_data_->device = _tmp1_;
	_tmp2_ = g_strdup (prop_name);
	_g_free0 (_data_->prop_name);
	_data_->prop_name = _tmp2_;
	sound_pulse_audio_manager_wait_for_update_co (_data_);
}

static void
sound_pulse_audio_manager_wait_for_update_finish (SoundPulseAudioManager* self,
                                                  GAsyncResult* _res_)
{
	SoundPulseAudioManagerWaitForUpdateData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		SoundPulseAudioManager* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->device);
		_g_free0 (_data2_->prop_name);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static void
__lambda10_ (Block2Data* _data2_,
             GObject* s,
             GParamSpec* p)
{
	SoundPulseAudioManager* self;
	gchar* prop_value = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	self = _data2_->self;
	g_return_if_fail (s != NULL);
	g_return_if_fail (p != NULL);
	g_object_get ((GObject*) _data2_->device, _data2_->prop_name, &_tmp0_, NULL);
	_g_free0 (prop_value);
	prop_value = _tmp0_;
	_tmp1_ = prop_value;
	if (_tmp1_ != NULL) {
		g_signal_handler_disconnect ((GObject*) _data2_->device, _data2_->handler_id);
		sound_pulse_audio_manager_wait_for_update_co (_data2_->_async_data_);
	}
	_g_free0 (prop_value);
}

static void
___lambda10__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda10_ (self, _sender, pspec);
}

static gboolean
sound_pulse_audio_manager_wait_for_update_co (SoundPulseAudioManagerWaitForUpdateData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data2_ = g_slice_new0 (Block2Data);
	_data_->_data2_->_ref_count_ = 1;
	_data_->_data2_->self = g_object_ref (_data_->self);
	_g_object_unref0 (_data_->_data2_->device);
	_data_->_data2_->device = _data_->device;
	_g_free0 (_data_->_data2_->prop_name);
	_data_->_data2_->prop_name = _data_->prop_name;
	_data_->_data2_->_async_data_ = _data_;
	_data_->_tmp0_ = sound_device_get_id (_data_->_data2_->device);
	_data_->_tmp1_ = _data_->_tmp0_;
	g_debug ("PulseAudioManager.vala:149: wait_for_update: %s:%s", _data_->_tmp1_, _data_->_data2_->prop_name);
	_data_->_data2_->handler_id = (gulong) 0;
	_data_->_tmp2_ = g_strconcat ("notify::", _data_->_data2_->prop_name, NULL);
	_data_->_tmp3_ = g_signal_connect_data ((GObject*) _data_->_data2_->device, _data_->_tmp2_, (GCallback) ___lambda10__g_object_notify, block2_data_ref (_data_->_data2_), (GClosureNotify) block2_data_unref, 0);
	_data_->_data2_->handler_id = _data_->_tmp3_;
	_g_free0 (_data_->_tmp2_);
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	block2_data_unref (_data_->_data2_);
	_data_->_data2_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
sound_pulse_audio_manager_set_sink_port_by_name_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetSinkPortByNameData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (SoundPulseAudioManagerSetSinkPortByNameData, _data_);
}

static void
sound_pulse_audio_manager_set_sink_port_by_name (SoundPulseAudioManager* self,
                                                 const gchar* sink_name,
                                                 const gchar* port_name,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_)
{
	SoundPulseAudioManagerSetSinkPortByNameData* _data_;
	SoundPulseAudioManager* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetSinkPortByNameData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_sink_port_by_name_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (sink_name);
	_g_free0 (_data_->sink_name);
	_data_->sink_name = _tmp1_;
	_tmp2_ = g_strdup (port_name);
	_g_free0 (_data_->port_name);
	_data_->port_name = _tmp2_;
	sound_pulse_audio_manager_set_sink_port_by_name_co (_data_);
}

static void
sound_pulse_audio_manager_set_sink_port_by_name_finish (SoundPulseAudioManager* self,
                                                        GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetSinkPortByNameData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		SoundPulseAudioManager* self;
		self = _data3_->self;
		_g_free0 (_data3_->sink_name);
		_g_free0 (_data3_->port_name);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}

static void
__lambda11_ (Block3Data* _data3_,
             pa_context* c,
             gint success)
{
	SoundPulseAudioManager* self;
	self = _data3_->self;
	g_return_if_fail (c != NULL);
	if (success == 1) {
		sound_pulse_audio_manager_set_sink_port_by_name_co (_data3_->_async_data_);
	} else {
		g_warning ("PulseAudioManager.vala:168: setting sink %s port to %s failed", _data3_->sink_name, _data3_->port_name);
	}
}

static void
___lambda11__pa_context_success_cb_t (pa_context* c,
                                      gint success,
                                      gpointer self)
{
	__lambda11_ (self, c, success);
}

static gboolean
sound_pulse_audio_manager_set_sink_port_by_name_co (SoundPulseAudioManagerSetSinkPortByNameData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data3_ = g_slice_new0 (Block3Data);
	_data_->_data3_->_ref_count_ = 1;
	_data_->_data3_->self = g_object_ref (_data_->self);
	_g_free0 (_data_->_data3_->sink_name);
	_data_->_data3_->sink_name = _data_->sink_name;
	_g_free0 (_data_->_data3_->port_name);
	_data_->_data3_->port_name = _data_->port_name;
	_data_->_data3_->_async_data_ = _data_;
	_data_->_tmp0_ = _data_->self->priv->_context;
	_data_->_tmp1_ = pa_context_set_sink_port_by_name (_data_->_tmp0_, _data_->_data3_->sink_name, _data_->_data3_->port_name, ___lambda11__pa_context_success_cb_t, _data_->_data3_);
	_data_->_tmp2_ = _data_->_tmp1_;
	_pa_operation_unref0 (_data_->_tmp2_);
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	block3_data_unref (_data_->_data3_);
	_data_->_data3_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
sound_pulse_audio_manager_set_source_port_by_name_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetSourcePortByNameData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (SoundPulseAudioManagerSetSourcePortByNameData, _data_);
}

static void
sound_pulse_audio_manager_set_source_port_by_name (SoundPulseAudioManager* self,
                                                   const gchar* source_name,
                                                   const gchar* port_name,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_)
{
	SoundPulseAudioManagerSetSourcePortByNameData* _data_;
	SoundPulseAudioManager* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetSourcePortByNameData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_source_port_by_name_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (source_name);
	_g_free0 (_data_->source_name);
	_data_->source_name = _tmp1_;
	_tmp2_ = g_strdup (port_name);
	_g_free0 (_data_->port_name);
	_data_->port_name = _tmp2_;
	sound_pulse_audio_manager_set_source_port_by_name_co (_data_);
}

static void
sound_pulse_audio_manager_set_source_port_by_name_finish (SoundPulseAudioManager* self,
                                                          GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetSourcePortByNameData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		SoundPulseAudioManager* self;
		self = _data4_->self;
		_g_free0 (_data4_->source_name);
		_g_free0 (_data4_->port_name);
		_g_object_unref0 (self);
		g_slice_free (Block4Data, _data4_);
	}
}

static void
__lambda12_ (Block4Data* _data4_,
             pa_context* c,
             gint success)
{
	SoundPulseAudioManager* self;
	self = _data4_->self;
	g_return_if_fail (c != NULL);
	if (success == 1) {
		sound_pulse_audio_manager_set_source_port_by_name_co (_data4_->_async_data_);
	} else {
		g_warning ("PulseAudioManager.vala:180: setting source %s port to %s failed", _data4_->source_name, _data4_->port_name);
	}
}

static void
___lambda12__pa_context_success_cb_t (pa_context* c,
                                      gint success,
                                      gpointer self)
{
	__lambda12_ (self, c, success);
}

static gboolean
sound_pulse_audio_manager_set_source_port_by_name_co (SoundPulseAudioManagerSetSourcePortByNameData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data4_ = g_slice_new0 (Block4Data);
	_data_->_data4_->_ref_count_ = 1;
	_data_->_data4_->self = g_object_ref (_data_->self);
	_g_free0 (_data_->_data4_->source_name);
	_data_->_data4_->source_name = _data_->source_name;
	_g_free0 (_data_->_data4_->port_name);
	_data_->_data4_->port_name = _data_->port_name;
	_data_->_data4_->_async_data_ = _data_;
	_data_->_tmp0_ = _data_->self->priv->_context;
	_data_->_tmp1_ = pa_context_set_source_port_by_name (_data_->_tmp0_, _data_->_data4_->source_name, _data_->_data4_->port_name, ___lambda12__pa_context_success_cb_t, _data_->_data4_);
	_data_->_tmp2_ = _data_->_tmp1_;
	_pa_operation_unref0 (_data_->_tmp2_);
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	block4_data_unref (_data_->_data4_);
	_data_->_data4_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
sound_pulse_audio_manager_set_default_sink_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetDefaultSinkData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (SoundPulseAudioManagerSetDefaultSinkData, _data_);
}

static void
sound_pulse_audio_manager_set_default_sink (SoundPulseAudioManager* self,
                                            const gchar* sink_name,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	SoundPulseAudioManagerSetDefaultSinkData* _data_;
	SoundPulseAudioManager* _tmp0_;
	gchar* _tmp1_;
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetDefaultSinkData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_default_sink_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (sink_name);
	_g_free0 (_data_->sink_name);
	_data_->sink_name = _tmp1_;
	sound_pulse_audio_manager_set_default_sink_co (_data_);
}

static void
sound_pulse_audio_manager_set_default_sink_finish (SoundPulseAudioManager* self,
                                                   GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetDefaultSinkData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		SoundPulseAudioManager* self;
		self = _data5_->self;
		_g_free0 (_data5_->sink_name);
		_g_object_unref0 (self);
		g_slice_free (Block5Data, _data5_);
	}
}

static void
__lambda13_ (Block5Data* _data5_,
             pa_context* c,
             gint success)
{
	SoundPulseAudioManager* self;
	self = _data5_->self;
	g_return_if_fail (c != NULL);
	if (success == 1) {
		sound_pulse_audio_manager_set_default_sink_co (_data5_->_async_data_);
	} else {
		g_warning ("PulseAudioManager.vala:192: setting default sink to %s failed", _data5_->sink_name);
	}
}

static void
___lambda13__pa_context_success_cb_t (pa_context* c,
                                      gint success,
                                      gpointer self)
{
	__lambda13_ (self, c, success);
}

static gboolean
sound_pulse_audio_manager_set_default_sink_co (SoundPulseAudioManagerSetDefaultSinkData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data5_ = g_slice_new0 (Block5Data);
	_data_->_data5_->_ref_count_ = 1;
	_data_->_data5_->self = g_object_ref (_data_->self);
	_g_free0 (_data_->_data5_->sink_name);
	_data_->_data5_->sink_name = _data_->sink_name;
	_data_->_data5_->_async_data_ = _data_;
	_data_->_tmp0_ = _data_->self->priv->_context;
	_data_->_tmp1_ = pa_context_set_default_sink (_data_->_tmp0_, _data_->_data5_->sink_name, ___lambda13__pa_context_success_cb_t, _data_->_data5_);
	_data_->_tmp2_ = _data_->_tmp1_;
	_pa_operation_unref0 (_data_->_tmp2_);
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	block5_data_unref (_data_->_data5_);
	_data_->_data5_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
sound_pulse_audio_manager_set_default_source_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetDefaultSourceData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (SoundPulseAudioManagerSetDefaultSourceData, _data_);
}

static void
sound_pulse_audio_manager_set_default_source (SoundPulseAudioManager* self,
                                              const gchar* source_name,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	SoundPulseAudioManagerSetDefaultSourceData* _data_;
	SoundPulseAudioManager* _tmp0_;
	gchar* _tmp1_;
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetDefaultSourceData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_default_source_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (source_name);
	_g_free0 (_data_->source_name);
	_data_->source_name = _tmp1_;
	sound_pulse_audio_manager_set_default_source_co (_data_);
}

static void
sound_pulse_audio_manager_set_default_source_finish (SoundPulseAudioManager* self,
                                                     GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetDefaultSourceData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		SoundPulseAudioManager* self;
		self = _data6_->self;
		_g_free0 (_data6_->source_name);
		_g_object_unref0 (self);
		g_slice_free (Block6Data, _data6_);
	}
}

static void
__lambda14_ (Block6Data* _data6_,
             pa_context* c,
             gint success)
{
	SoundPulseAudioManager* self;
	self = _data6_->self;
	g_return_if_fail (c != NULL);
	if (success == 1) {
		sound_pulse_audio_manager_set_default_source_co (_data6_->_async_data_);
	} else {
		g_warning ("PulseAudioManager.vala:204: setting default source to %s failed", _data6_->source_name);
	}
}

static void
___lambda14__pa_context_success_cb_t (pa_context* c,
                                      gint success,
                                      gpointer self)
{
	__lambda14_ (self, c, success);
}

static gboolean
sound_pulse_audio_manager_set_default_source_co (SoundPulseAudioManagerSetDefaultSourceData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data6_ = g_slice_new0 (Block6Data);
	_data_->_data6_->_ref_count_ = 1;
	_data_->_data6_->self = g_object_ref (_data_->self);
	_g_free0 (_data_->_data6_->source_name);
	_data_->_data6_->source_name = _data_->source_name;
	_data_->_data6_->_async_data_ = _data_;
	_data_->_tmp0_ = _data_->self->priv->_context;
	_data_->_tmp1_ = pa_context_set_default_source (_data_->_tmp0_, _data_->_data6_->source_name, ___lambda14__pa_context_success_cb_t, _data_->_data6_);
	_data_->_tmp2_ = _data_->_tmp1_;
	_pa_operation_unref0 (_data_->_tmp2_);
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	block6_data_unref (_data_->_data6_);
	_data_->_data6_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

void
sound_pulse_audio_manager_change_device_mute (SoundPulseAudioManager* self,
                                              SoundDevice* device,
                                              gboolean mute)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	if (device == NULL) {
		return;
	}
	_tmp0_ = sound_device_get_input (device);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		pa_context* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		pa_operation* _tmp5_;
		pa_operation* _tmp6_;
		_tmp2_ = self->priv->_context;
		_tmp3_ = sound_device_get_source_name (device);
		_tmp4_ = _tmp3_;
		_tmp5_ = pa_context_set_source_mute_by_name (_tmp2_, _tmp4_, mute, NULL, NULL);
		_tmp6_ = _tmp5_;
		_pa_operation_unref0 (_tmp6_);
	} else {
		pa_context* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		pa_operation* _tmp10_;
		pa_operation* _tmp11_;
		_tmp7_ = self->priv->_context;
		_tmp8_ = sound_device_get_sink_name (device);
		_tmp9_ = _tmp8_;
		_tmp10_ = pa_context_set_sink_mute_by_name (_tmp7_, _tmp9_, mute, NULL, NULL);
		_tmp11_ = _tmp10_;
		_pa_operation_unref0 (_tmp11_);
	}
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
	g_atomic_int_inc (&_data7_->_ref_count_);
	return _data7_;
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
		SoundPulseAudioManager* self;
		self = _data7_->self;
		_g_object_unref0 (_data7_->device);
		_g_object_unref0 (self);
		g_slice_free (Block7Data, _data7_);
	}
}

static gboolean
__lambda15_ (Block7Data* _data7_,
             pa_operation* operation)
{
	SoundPulseAudioManager* self;
	GeeLinkedList* _tmp0_;
	gboolean result = FALSE;
	self = _data7_->self;
	g_return_val_if_fail (operation != NULL, FALSE);
	if (pa_operation_get_state (operation) == PA_OPERATION_RUNNING) {
		pa_operation_cancel (operation);
	}
	_tmp0_ = _data7_->device->volume_operations;
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, operation);
	result = G_SOURCE_CONTINUE;
	_pa_operation_unref0 (operation);
	return result;
}

static gboolean
___lambda15__gee_forall_func (gpointer g,
                              gpointer self)
{
	gboolean result;
	result = __lambda15_ (self, (pa_operation*) g);
	return result;
}

void
sound_pulse_audio_manager_change_device_volume (SoundPulseAudioManager* self,
                                                SoundDevice* device,
                                                gdouble volume)
{
	Block7Data* _data7_;
	SoundDevice* _tmp0_;
	GeeLinkedList* _tmp1_;
	pa_cvolume cvol = {0};
	pa_cvolume _tmp2_;
	pa_operation* operation = NULL;
	gboolean _tmp3_;
	gboolean _tmp4_;
	pa_operation* _tmp15_;
	g_return_if_fail (self != NULL);
	_data7_ = g_slice_new0 (Block7Data);
	_data7_->_ref_count_ = 1;
	_data7_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (device);
	_g_object_unref0 (_data7_->device);
	_data7_->device = _tmp0_;
	if (_data7_->device == NULL) {
		block7_data_unref (_data7_);
		_data7_ = NULL;
		return;
	}
	_tmp1_ = _data7_->device->volume_operations;
	gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp1_, ___lambda15__gee_forall_func, _data7_);
	_tmp2_ = _data7_->device->cvolume;
	cvol = _tmp2_;
	pa_cvolume_scale (&cvol, sound_pulse_audio_manager_double_to_volume (volume));
	operation = NULL;
	_tmp3_ = sound_device_get_input (_data7_->device);
	_tmp4_ = _tmp3_;
	if (_tmp4_) {
		pa_context* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		pa_cvolume _tmp8_;
		pa_operation* _tmp9_;
		_tmp5_ = self->priv->_context;
		_tmp6_ = sound_device_get_source_name (_data7_->device);
		_tmp7_ = _tmp6_;
		_tmp8_ = cvol;
		_tmp9_ = pa_context_set_source_volume_by_name (_tmp5_, _tmp7_, &_tmp8_, NULL, NULL);
		_pa_operation_unref0 (operation);
		operation = _tmp9_;
	} else {
		pa_context* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		pa_cvolume _tmp13_;
		pa_operation* _tmp14_;
		_tmp10_ = self->priv->_context;
		_tmp11_ = sound_device_get_sink_name (_data7_->device);
		_tmp12_ = _tmp11_;
		_tmp13_ = cvol;
		_tmp14_ = pa_context_set_sink_volume_by_name (_tmp10_, _tmp12_, &_tmp13_, NULL, NULL);
		_pa_operation_unref0 (operation);
		operation = _tmp14_;
	}
	_tmp15_ = operation;
	if (_tmp15_ != NULL) {
		GeeLinkedList* _tmp16_;
		pa_operation* _tmp17_;
		_tmp16_ = _data7_->device->volume_operations;
		_tmp17_ = operation;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
	}
	_pa_operation_unref0 (operation);
	block7_data_unref (_data7_);
	_data7_ = NULL;
}

void
sound_pulse_audio_manager_change_device_balance (SoundPulseAudioManager* self,
                                                 SoundDevice* device,
                                                 gfloat balance)
{
	pa_cvolume cvol = {0};
	pa_cvolume _tmp0_;
	pa_channel_map _tmp1_;
	pa_operation* operation = NULL;
	gboolean _tmp2_;
	gboolean _tmp3_;
	pa_operation* _tmp14_;
	g_return_if_fail (self != NULL);
	if (device == NULL) {
		return;
	}
	_tmp0_ = device->cvolume;
	cvol = _tmp0_;
	_tmp1_ = device->channel_map;
	cvol = *pa_cvolume_set_balance (&cvol, &_tmp1_, balance);
	operation = NULL;
	_tmp2_ = sound_device_get_input (device);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		pa_context* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		pa_cvolume _tmp7_;
		pa_operation* _tmp8_;
		_tmp4_ = self->priv->_context;
		_tmp5_ = sound_device_get_source_name (device);
		_tmp6_ = _tmp5_;
		_tmp7_ = cvol;
		_tmp8_ = pa_context_set_source_volume_by_name (_tmp4_, _tmp6_, &_tmp7_, NULL, NULL);
		_pa_operation_unref0 (operation);
		operation = _tmp8_;
	} else {
		pa_context* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		pa_cvolume _tmp12_;
		pa_operation* _tmp13_;
		_tmp9_ = self->priv->_context;
		_tmp10_ = sound_device_get_sink_name (device);
		_tmp11_ = _tmp10_;
		_tmp12_ = cvol;
		_tmp13_ = pa_context_set_sink_volume_by_name (_tmp9_, _tmp11_, &_tmp12_, NULL, NULL);
		_pa_operation_unref0 (operation);
		operation = _tmp13_;
	}
	_tmp14_ = operation;
	if (_tmp14_ != NULL) {
		GeeLinkedList* _tmp15_;
		pa_operation* _tmp16_;
		_tmp15_ = device->volume_operations;
		_tmp16_ = operation;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
	}
	_pa_operation_unref0 (operation);
}

static gboolean
sound_pulse_audio_manager_reconnect_timeout (SoundPulseAudioManager* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	self->priv->reconnect_timer_id = 0U;
	sound_pulse_audio_manager_reconnect_to_pulse (self, NULL, NULL);
	result = FALSE;
	return result;
}

static void
sound_pulse_audio_manager_reconnect_to_pulse_data_free (gpointer _data)
{
	SoundPulseAudioManagerReconnectToPulseData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (SoundPulseAudioManagerReconnectToPulseData, _data_);
}

static void
sound_pulse_audio_manager_reconnect_to_pulse (SoundPulseAudioManager* self,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	SoundPulseAudioManagerReconnectToPulseData* _data_;
	SoundPulseAudioManager* _tmp0_;
	_data_ = g_slice_new0 (SoundPulseAudioManagerReconnectToPulseData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_reconnect_to_pulse_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	sound_pulse_audio_manager_reconnect_to_pulse_co (_data_);
}

static void
sound_pulse_audio_manager_reconnect_to_pulse_finish (SoundPulseAudioManager* self,
                                                     GAsyncResult* _res_)
{
	SoundPulseAudioManagerReconnectToPulseData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
_sound_pulse_audio_manager_context_state_callback_pa_context_notify_cb_t (pa_context* c,
                                                                          gpointer self)
{
	sound_pulse_audio_manager_context_state_callback ((SoundPulseAudioManager*) self, c);
}

static gboolean
sound_pulse_audio_manager_reconnect_to_pulse_co (SoundPulseAudioManagerReconnectToPulseData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	if (_data_->self->priv->is_ready) {
		_data_->_tmp0_ = _data_->self->priv->_context;
		pa_context_disconnect (_data_->_tmp0_);
		sound_pulse_audio_manager_set_context (_data_->self, NULL);
		_data_->self->priv->is_ready = FALSE;
	}
	_data_->_tmp1_ = pa_proplist_new ();
	_data_->props = _data_->_tmp1_;
	_data_->_tmp2_ = _data_->props;
	pa_proplist_sets (_data_->_tmp2_, PA_PROP_APPLICATION_ID, "org.pantheon.switchboard.plug.sound");
	_data_->_tmp3_ = _data_->self->priv->loop;
	_data_->_tmp4_ = pa_glib_mainloop_get_api (_data_->_tmp3_);
	_data_->_tmp5_ = _data_->props;
	_data_->_tmp6_ = pa_context_new_with_proplist (_data_->_tmp4_, NULL, _data_->_tmp5_);
	_data_->_tmp7_ = _data_->_tmp6_;
	sound_pulse_audio_manager_set_context (_data_->self, _data_->_tmp7_);
	_pa_context_unref0 (_data_->_tmp7_);
	_data_->_tmp8_ = _data_->self->priv->_context;
	pa_context_set_state_callback (_data_->_tmp8_, _sound_pulse_audio_manager_context_state_callback_pa_context_notify_cb_t, _data_->self);
	_data_->_tmp9_ = _data_->self->priv->_context;
	if (pa_context_connect (_data_->_tmp9_, NULL, PA_CONTEXT_NOFAIL, NULL) < 0) {
		_data_->_tmp10_ = _data_->self->priv->_context;
		_data_->_tmp11_ = pa_strerror (pa_context_errno (_data_->_tmp10_));
		g_warning ("PulseAudioManager.vala:293: pa_context_connect () failed: %s\n", _data_->_tmp11_);
	}
	_pa_proplist_free0 (_data_->props);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
_sound_pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t (pa_context* c,
                                                                         pa_subscription_event_type_t t,
                                                                         guint32 idx,
                                                                         gpointer self)
{
	sound_pulse_audio_manager_subscribe_callback ((SoundPulseAudioManager*) self, c, t, idx);
}

static void
_sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t (pa_context* c,
                                                                     pa_server_info* i,
                                                                     gpointer self)
{
	sound_pulse_audio_manager_server_info_callback ((SoundPulseAudioManager*) self, c, i);
}

static gboolean
_sound_pulse_audio_manager_reconnect_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = sound_pulse_audio_manager_reconnect_timeout ((SoundPulseAudioManager*) self);
	return result;
}

static void
sound_pulse_audio_manager_context_state_callback (SoundPulseAudioManager* self,
                                                  pa_context* c)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	switch (pa_context_get_state (c)) {
		case PA_CONTEXT_READY:
		{
			pa_operation* _tmp0_;
			pa_operation* _tmp1_;
			pa_context* _tmp2_;
			pa_operation* _tmp3_;
			pa_operation* _tmp4_;
			pa_context_set_subscribe_callback (c, _sound_pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t, self);
			_tmp0_ = pa_context_subscribe (c, ((((PA_SUBSCRIPTION_MASK_SERVER | PA_SUBSCRIPTION_MASK_SINK) | PA_SUBSCRIPTION_MASK_SOURCE) | PA_SUBSCRIPTION_MASK_SINK_INPUT) | PA_SUBSCRIPTION_MASK_SOURCE_OUTPUT) | PA_SUBSCRIPTION_MASK_CARD, NULL, NULL);
			_tmp1_ = _tmp0_;
			_pa_operation_unref0 (_tmp1_);
			_tmp2_ = self->priv->_context;
			_tmp3_ = pa_context_get_server_info (_tmp2_, _sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t, self);
			_tmp4_ = _tmp3_;
			_pa_operation_unref0 (_tmp4_);
			self->priv->is_ready = TRUE;
			break;
		}
		case PA_CONTEXT_FAILED:
		case PA_CONTEXT_TERMINATED:
		{
			if (self->priv->reconnect_timer_id == 0U) {
				self->priv->reconnect_timer_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, _sound_pulse_audio_manager_reconnect_timeout_gsource_func, g_object_ref (self), g_object_unref);
			}
			break;
		}
		default:
		{
			self->priv->is_ready = FALSE;
			break;
		}
	}
}

static void
_sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t (pa_context* c,
                                                                 pa_sink_info* i,
                                                                 gint eol,
                                                                 gpointer self)
{
	sound_pulse_audio_manager_sink_info_callback ((SoundPulseAudioManager*) self, c, i, eol);
}

static void
_sound_pulse_audio_manager_card_info_callback_pa_card_info_cb_t (pa_context* c,
                                                                 pa_card_info* i,
                                                                 gint eol,
                                                                 gpointer self)
{
	sound_pulse_audio_manager_card_info_callback ((SoundPulseAudioManager*) self, c, i, eol);
}

static void
_sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t (pa_context* c,
                                                                     pa_source_info* i,
                                                                     gint eol,
                                                                     gpointer self)
{
	sound_pulse_audio_manager_source_info_callback ((SoundPulseAudioManager*) self, c, i, eol);
}

static void
sound_pulse_audio_manager_subscribe_callback (SoundPulseAudioManager* self,
                                              pa_context* c,
                                              pa_subscription_event_type_t t,
                                              guint32 index)
{
	pa_subscription_event_type_t source_type = 0;
	pa_subscription_event_type_t _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	source_type = t & PA_SUBSCRIPTION_EVENT_FACILITY_MASK;
	_tmp0_ = source_type;
	switch (_tmp0_) {
		case PA_SUBSCRIPTION_EVENT_SINK:
		case PA_SUBSCRIPTION_EVENT_SINK_INPUT:
		{
			pa_subscription_event_type_t event_type = 0;
			pa_subscription_event_type_t _tmp1_;
			event_type = t & PA_SUBSCRIPTION_EVENT_TYPE_MASK;
			_tmp1_ = event_type;
			switch (_tmp1_) {
				case PA_SUBSCRIPTION_EVENT_NEW:
				{
					pa_operation* _tmp2_;
					pa_operation* _tmp3_;
					_tmp2_ = pa_context_get_sink_info_by_index (c, index, _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t, self);
					_tmp3_ = _tmp2_;
					_pa_operation_unref0 (_tmp3_);
					break;
				}
				case PA_SUBSCRIPTION_EVENT_CHANGE:
				{
					pa_operation* _tmp4_;
					pa_operation* _tmp5_;
					_tmp4_ = pa_context_get_sink_info_by_index (c, index, _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t, self);
					_tmp5_ = _tmp4_;
					_pa_operation_unref0 (_tmp5_);
					break;
				}
				case PA_SUBSCRIPTION_EVENT_REMOVE:
				{
					g_debug ("PulseAudioManager.vala:345: subscribe_callback:SINK:REMOVE");
					{
						GeeIterator* _device_it = NULL;
						GeeHashMap* _tmp6_;
						GeeCollection* _tmp7_;
						GeeCollection* _tmp8_;
						GeeCollection* _tmp9_;
						GeeIterator* _tmp10_;
						GeeIterator* _tmp11_;
						_tmp6_ = self->priv->output_devices;
						_tmp7_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp6_);
						_tmp8_ = _tmp7_;
						_tmp9_ = _tmp8_;
						_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
						_tmp11_ = _tmp10_;
						_g_object_unref0 (_tmp9_);
						_device_it = _tmp11_;
						while (TRUE) {
							GeeIterator* _tmp12_;
							SoundDevice* device = NULL;
							GeeIterator* _tmp13_;
							gpointer _tmp14_;
							SoundDevice* _tmp15_;
							gint _tmp16_;
							gint _tmp17_;
							SoundDevice* _tmp27_;
							gint _tmp28_;
							gint _tmp29_;
							_tmp12_ = _device_it;
							if (!gee_iterator_next (_tmp12_)) {
								break;
							}
							_tmp13_ = _device_it;
							_tmp14_ = gee_iterator_get (_tmp13_);
							device = (SoundDevice*) _tmp14_;
							_tmp15_ = device;
							_tmp16_ = sound_device_get_sink_index (_tmp15_);
							_tmp17_ = _tmp16_;
							if (((guint32) _tmp17_) == index) {
								SoundDevice* _tmp18_;
								const gchar* _tmp19_;
								const gchar* _tmp20_;
								SoundDevice* _tmp21_;
								SoundDevice* _tmp22_;
								SoundDevice* _tmp23_;
								SoundDevice* _tmp24_;
								const gchar* _tmp25_;
								const gchar* _tmp26_;
								_tmp18_ = device;
								_tmp19_ = sound_device_get_id (_tmp18_);
								_tmp20_ = _tmp19_;
								g_debug ("PulseAudioManager.vala:348: \tupdating device: %s", _tmp20_);
								_tmp21_ = device;
								sound_device_set_sink_name (_tmp21_, NULL);
								_tmp22_ = device;
								sound_device_set_sink_index (_tmp22_, -1);
								_tmp23_ = device;
								sound_device_set_is_default (_tmp23_, FALSE);
								_tmp24_ = device;
								_tmp25_ = sound_device_get_sink_name (_tmp24_);
								_tmp26_ = _tmp25_;
								g_debug ("PulseAudioManager.vala:352: \t\tdevice.sink_name: %s", _tmp26_);
							}
							_tmp27_ = device;
							_tmp28_ = sound_device_get_card_sink_index (_tmp27_);
							_tmp29_ = _tmp28_;
							if (((guint32) _tmp29_) == index) {
								SoundDevice* _tmp30_;
								const gchar* _tmp31_;
								const gchar* _tmp32_;
								SoundDevice* _tmp33_;
								SoundDevice* _tmp34_;
								SoundDevice* _tmp35_;
								SoundDevice* _tmp36_;
								const gchar* _tmp37_;
								const gchar* _tmp38_;
								_tmp30_ = device;
								_tmp31_ = sound_device_get_id (_tmp30_);
								_tmp32_ = _tmp31_;
								g_debug ("PulseAudioManager.vala:356: \tupdating device: %s", _tmp32_);
								_tmp33_ = device;
								sound_device_set_card_sink_name (_tmp33_, NULL);
								_tmp34_ = device;
								sound_device_set_card_sink_index (_tmp34_, -1);
								_tmp35_ = device;
								sound_device_set_card_sink_port_name (_tmp35_, NULL);
								_tmp36_ = device;
								_tmp37_ = sound_device_get_card_sink_name (_tmp36_);
								_tmp38_ = _tmp37_;
								g_debug ("PulseAudioManager.vala:360: \t\tdevice.card_sink_name: %s", _tmp38_);
							}
							_g_object_unref0 (device);
						}
						_g_object_unref0 (_device_it);
					}
					break;
				}
				default:
				break;
			}
			break;
		}
		case PA_SUBSCRIPTION_EVENT_SERVER:
		{
			pa_context* _tmp39_;
			pa_operation* _tmp40_;
			pa_operation* _tmp41_;
			_tmp39_ = self->priv->_context;
			_tmp40_ = pa_context_get_server_info (_tmp39_, _sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t, self);
			_tmp41_ = _tmp40_;
			_pa_operation_unref0 (_tmp41_);
			break;
		}
		case PA_SUBSCRIPTION_EVENT_CARD:
		{
			pa_subscription_event_type_t event_type = 0;
			pa_subscription_event_type_t _tmp42_;
			event_type = t & PA_SUBSCRIPTION_EVENT_TYPE_MASK;
			_tmp42_ = event_type;
			switch (_tmp42_) {
				case PA_SUBSCRIPTION_EVENT_NEW:
				{
					pa_operation* _tmp43_;
					pa_operation* _tmp44_;
					_tmp43_ = pa_context_get_card_info_by_index (c, index, _sound_pulse_audio_manager_card_info_callback_pa_card_info_cb_t, self);
					_tmp44_ = _tmp43_;
					_pa_operation_unref0 (_tmp44_);
					break;
				}
				case PA_SUBSCRIPTION_EVENT_CHANGE:
				{
					pa_operation* _tmp45_;
					pa_operation* _tmp46_;
					_tmp45_ = pa_context_get_card_info_by_index (c, index, _sound_pulse_audio_manager_card_info_callback_pa_card_info_cb_t, self);
					_tmp46_ = _tmp45_;
					_pa_operation_unref0 (_tmp46_);
					break;
				}
				case PA_SUBSCRIPTION_EVENT_REMOVE:
				{
					GeeHashMap* _tmp47_;
					GeeHashMap* _tmp48_;
					_tmp47_ = self->priv->output_devices;
					sound_pulse_audio_manager_remove_devices_by_card (self, _tmp47_, index);
					_tmp48_ = self->priv->input_devices;
					sound_pulse_audio_manager_remove_devices_by_card (self, _tmp48_, index);
					break;
				}
				default:
				break;
			}
			break;
		}
		case PA_SUBSCRIPTION_EVENT_SOURCE:
		case PA_SUBSCRIPTION_EVENT_SOURCE_OUTPUT:
		{
			pa_subscription_event_type_t event_type = 0;
			pa_subscription_event_type_t _tmp49_;
			event_type = t & PA_SUBSCRIPTION_EVENT_TYPE_MASK;
			_tmp49_ = event_type;
			switch (_tmp49_) {
				case PA_SUBSCRIPTION_EVENT_NEW:
				{
					pa_operation* _tmp50_;
					pa_operation* _tmp51_;
					_tmp50_ = pa_context_get_source_info_by_index (c, index, _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t, self);
					_tmp51_ = _tmp50_;
					_pa_operation_unref0 (_tmp51_);
					break;
				}
				case PA_SUBSCRIPTION_EVENT_CHANGE:
				{
					pa_operation* _tmp52_;
					pa_operation* _tmp53_;
					_tmp52_ = pa_context_get_source_info_by_index (c, index, _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t, self);
					_tmp53_ = _tmp52_;
					_pa_operation_unref0 (_tmp53_);
					break;
				}
				case PA_SUBSCRIPTION_EVENT_REMOVE:
				{
					g_debug ("PulseAudioManager.vala:405: subscribe_callback:SOURCE:REMOVE");
					{
						GeeIterator* _device_it = NULL;
						GeeHashMap* _tmp54_;
						GeeCollection* _tmp55_;
						GeeCollection* _tmp56_;
						GeeCollection* _tmp57_;
						GeeIterator* _tmp58_;
						GeeIterator* _tmp59_;
						_tmp54_ = self->priv->input_devices;
						_tmp55_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp54_);
						_tmp56_ = _tmp55_;
						_tmp57_ = _tmp56_;
						_tmp58_ = gee_iterable_iterator ((GeeIterable*) _tmp57_);
						_tmp59_ = _tmp58_;
						_g_object_unref0 (_tmp57_);
						_device_it = _tmp59_;
						while (TRUE) {
							GeeIterator* _tmp60_;
							SoundDevice* device = NULL;
							GeeIterator* _tmp61_;
							gpointer _tmp62_;
							SoundDevice* _tmp63_;
							gint _tmp64_;
							gint _tmp65_;
							SoundDevice* _tmp75_;
							gint _tmp76_;
							gint _tmp77_;
							_tmp60_ = _device_it;
							if (!gee_iterator_next (_tmp60_)) {
								break;
							}
							_tmp61_ = _device_it;
							_tmp62_ = gee_iterator_get (_tmp61_);
							device = (SoundDevice*) _tmp62_;
							_tmp63_ = device;
							_tmp64_ = sound_device_get_source_index (_tmp63_);
							_tmp65_ = _tmp64_;
							if (((guint32) _tmp65_) == index) {
								SoundDevice* _tmp66_;
								const gchar* _tmp67_;
								const gchar* _tmp68_;
								SoundDevice* _tmp69_;
								SoundDevice* _tmp70_;
								SoundDevice* _tmp71_;
								SoundDevice* _tmp72_;
								const gchar* _tmp73_;
								const gchar* _tmp74_;
								_tmp66_ = device;
								_tmp67_ = sound_device_get_id (_tmp66_);
								_tmp68_ = _tmp67_;
								g_debug ("PulseAudioManager.vala:408: \tupdating device: %s", _tmp68_);
								_tmp69_ = device;
								sound_device_set_source_name (_tmp69_, NULL);
								_tmp70_ = device;
								sound_device_set_source_index (_tmp70_, -1);
								_tmp71_ = device;
								sound_device_set_is_default (_tmp71_, FALSE);
								_tmp72_ = device;
								_tmp73_ = sound_device_get_source_name (_tmp72_);
								_tmp74_ = _tmp73_;
								g_debug ("PulseAudioManager.vala:412: \t\tdevice.source_name: %s", _tmp74_);
							}
							_tmp75_ = device;
							_tmp76_ = sound_device_get_card_source_index (_tmp75_);
							_tmp77_ = _tmp76_;
							if (((guint32) _tmp77_) == index) {
								SoundDevice* _tmp78_;
								const gchar* _tmp79_;
								const gchar* _tmp80_;
								SoundDevice* _tmp81_;
								SoundDevice* _tmp82_;
								SoundDevice* _tmp83_;
								SoundDevice* _tmp84_;
								const gchar* _tmp85_;
								const gchar* _tmp86_;
								_tmp78_ = device;
								_tmp79_ = sound_device_get_id (_tmp78_);
								_tmp80_ = _tmp79_;
								g_debug ("PulseAudioManager.vala:416: \tupdating device: %s", _tmp80_);
								_tmp81_ = device;
								sound_device_set_card_source_name (_tmp81_, NULL);
								_tmp82_ = device;
								sound_device_set_card_source_index (_tmp82_, -1);
								_tmp83_ = device;
								sound_device_set_card_source_port_name (_tmp83_, NULL);
								_tmp84_ = device;
								_tmp85_ = sound_device_get_card_source_name (_tmp84_);
								_tmp86_ = _tmp85_;
								g_debug ("PulseAudioManager.vala:420: \t\tdevice.card_source_name: %s", _tmp86_);
							}
							_g_object_unref0 (device);
						}
						_g_object_unref0 (_device_it);
					}
					break;
				}
				default:
				break;
			}
			break;
		}
		default:
		break;
	}
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
	g_atomic_int_inc (&_data8_->_ref_count_);
	return _data8_;
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
		SoundPulseAudioManager* self;
		self = _data8_->self;
		_g_object_unref0 (_data8_->device);
		_g_object_unref0 (self);
		g_slice_free (Block8Data, _data8_);
	}
}

static gboolean
______lambda8_ (Block8Data* _data8_,
                pa_operation* operation)
{
	SoundPulseAudioManager* self;
	gboolean result = FALSE;
	self = _data8_->self;
	g_return_val_if_fail (operation != NULL, FALSE);
	if (pa_operation_get_state (operation) != PA_OPERATION_RUNNING) {
		SoundDevice* _tmp0_;
		GeeLinkedList* _tmp1_;
		_tmp0_ = _data8_->device;
		_tmp1_ = _tmp0_->volume_operations;
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, operation);
	}
	result = G_SOURCE_CONTINUE;
	_pa_operation_unref0 (operation);
	return result;
}

static gboolean
_______lambda8__gee_forall_func (gpointer g,
                                 gpointer self)
{
	gboolean result;
	result = ______lambda8_ (self, (pa_operation*) g);
	return result;
}

static void
sound_pulse_audio_manager_source_info_callback (SoundPulseAudioManager* self,
                                                pa_context* c,
                                                pa_source_info* source,
                                                gint eol)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	pa_source_port_info* _tmp8_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	if (source == NULL) {
		return;
	}
	if ((*source).monitor_of_sink != PA_INVALID_INDEX) {
		return;
	}
	g_debug ("PulseAudioManager.vala:445: source info update");
	_tmp0_ = (*source).description;
	_tmp1_ = (*source).name;
	g_debug ("PulseAudioManager.vala:446: \tsource: %s (%s)", _tmp0_, _tmp1_);
	g_debug ("PulseAudioManager.vala:447: \t\tcard: %u", (guint) (*source).card);
	_tmp2_ = (*source).name;
	if (g_strcmp0 (_tmp2_, "auto_null") == 0) {
		return;
	}
	if (sound_pulse_audio_manager_debug_enabled) {
		pa_source_port_info** _tmp3_;
		gint _tmp3__length1;
		_tmp3_ = (*source).ports;
		_tmp3__length1 = (*source).n_ports;
		{
			pa_source_port_info** port_collection = NULL;
			gint port_collection_length1 = 0;
			gint _port_collection_size_ = 0;
			gint port_it = 0;
			port_collection = _tmp3_;
			port_collection_length1 = _tmp3__length1;
			for (port_it = 0; port_it < port_collection_length1; port_it = port_it + 1) {
				pa_source_port_info* port = NULL;
				port = port_collection[port_it];
				{
					pa_source_port_info* _tmp4_;
					const gchar* _tmp5_;
					pa_source_port_info* _tmp6_;
					const gchar* _tmp7_;
					_tmp4_ = port;
					_tmp5_ = (*_tmp4_).description;
					_tmp6_ = port;
					_tmp7_ = (*_tmp6_).name;
					g_debug ("PulseAudioManager.vala:455: \t\tport: %s (%s)", _tmp5_, _tmp7_);
				}
			}
		}
	}
	_tmp8_ = (*source).active_port;
	if (_tmp8_ != NULL) {
		pa_source_port_info* _tmp9_;
		const gchar* _tmp10_;
		pa_source_port_info* _tmp11_;
		const gchar* _tmp12_;
		_tmp9_ = (*source).active_port;
		_tmp10_ = (*_tmp9_).description;
		_tmp11_ = (*source).active_port;
		_tmp12_ = (*_tmp11_).name;
		g_debug ("PulseAudioManager.vala:460: \t\tactive port: %s (%s)", _tmp10_, _tmp12_);
	}
	{
		GeeIterator* _device_it = NULL;
		GeeHashMap* _tmp13_;
		GeeCollection* _tmp14_;
		GeeCollection* _tmp15_;
		GeeCollection* _tmp16_;
		GeeIterator* _tmp17_;
		GeeIterator* _tmp18_;
		_tmp13_ = self->priv->input_devices;
		_tmp14_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = _tmp15_;
		_tmp17_ = gee_iterable_iterator ((GeeIterable*) _tmp16_);
		_tmp18_ = _tmp17_;
		_g_object_unref0 (_tmp16_);
		_device_it = _tmp18_;
		while (TRUE) {
			Block8Data* _data8_;
			GeeIterator* _tmp19_;
			GeeIterator* _tmp20_;
			gpointer _tmp21_;
			SoundDevice* _tmp22_;
			guint32 _tmp23_;
			guint32 _tmp24_;
			_data8_ = g_slice_new0 (Block8Data);
			_data8_->_ref_count_ = 1;
			_data8_->self = g_object_ref (self);
			_tmp19_ = _device_it;
			if (!gee_iterator_next (_tmp19_)) {
				block8_data_unref (_data8_);
				_data8_ = NULL;
				break;
			}
			_tmp20_ = _device_it;
			_tmp21_ = gee_iterator_get (_tmp20_);
			_data8_->device = (SoundDevice*) _tmp21_;
			_tmp22_ = _data8_->device;
			_tmp23_ = sound_device_get_card_index (_tmp22_);
			_tmp24_ = _tmp23_;
			if (_tmp24_ == (*source).card) {
				SoundDevice* _tmp25_;
				const gchar* _tmp26_;
				const gchar* _tmp27_;
				SoundDevice* _tmp28_;
				SoundDevice* _tmp29_;
				const gchar* _tmp30_;
				SoundDevice* _tmp31_;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
				gboolean _tmp34_ = FALSE;
				pa_source_port_info* _tmp35_;
				_tmp25_ = _data8_->device;
				_tmp26_ = sound_device_get_id (_tmp25_);
				_tmp27_ = _tmp26_;
				g_debug ("PulseAudioManager.vala:465: \t\tupdating device: %s", _tmp27_);
				_tmp28_ = _data8_->device;
				sound_device_set_card_source_index (_tmp28_, (gint) (*source).index);
				_tmp29_ = _data8_->device;
				_tmp30_ = (*source).name;
				sound_device_set_card_source_name (_tmp29_, _tmp30_);
				_tmp31_ = _data8_->device;
				_tmp32_ = sound_device_get_card_source_name (_tmp31_);
				_tmp33_ = _tmp32_;
				g_debug ("PulseAudioManager.vala:468: \t\t\tdevice.card_source_name: %s", _tmp33_);
				_tmp35_ = (*source).active_port;
				if (_tmp35_ != NULL) {
					SoundDevice* _tmp36_;
					const gchar* _tmp37_;
					const gchar* _tmp38_;
					pa_source_port_info* _tmp39_;
					const gchar* _tmp40_;
					_tmp36_ = _data8_->device;
					_tmp37_ = sound_device_get_port_name (_tmp36_);
					_tmp38_ = _tmp37_;
					_tmp39_ = (*source).active_port;
					_tmp40_ = (*_tmp39_).name;
					_tmp34_ = g_strcmp0 (_tmp38_, _tmp40_) == 0;
				} else {
					_tmp34_ = FALSE;
				}
				if (_tmp34_) {
					SoundDevice* _tmp41_;
					pa_source_port_info* _tmp42_;
					const gchar* _tmp43_;
					SoundDevice* _tmp44_;
					const gchar* _tmp45_;
					SoundDevice* _tmp46_;
					const gchar* _tmp47_;
					const gchar* _tmp48_;
					SoundDevice* _tmp49_;
					SoundDevice* _tmp50_;
					const gchar* _tmp51_;
					const gchar* _tmp52_;
					const gchar* _tmp53_ = NULL;
					SoundDevice* _tmp54_;
					gboolean _tmp55_;
					gboolean _tmp56_;
					SoundDevice* _tmp57_;
					SoundDevice* _tmp58_;
					pa_cvolume _tmp59_;
					SoundDevice* _tmp60_;
					pa_channel_map _tmp61_;
					SoundDevice* _tmp62_;
					pa_channel_map _tmp63_;
					SoundDevice* _tmp64_;
					GeeLinkedList* _tmp65_;
					SoundDevice* _tmp66_;
					GeeLinkedList* _tmp67_;
					gboolean _tmp68_;
					gboolean _tmp69_;
					SoundDevice* _tmp71_;
					gboolean _tmp72_;
					gboolean _tmp73_;
					_tmp41_ = _data8_->device;
					_tmp42_ = (*source).active_port;
					_tmp43_ = (*_tmp42_).name;
					sound_device_set_card_source_port_name (_tmp41_, _tmp43_);
					_tmp44_ = _data8_->device;
					_tmp45_ = (*source).name;
					sound_device_set_source_name (_tmp44_, _tmp45_);
					_tmp46_ = _data8_->device;
					_tmp47_ = sound_device_get_card_source_name (_tmp46_);
					_tmp48_ = _tmp47_;
					g_debug ("PulseAudioManager.vala:472: \t\t\tdevice.source_name: %s", _tmp48_);
					_tmp49_ = _data8_->device;
					sound_device_set_source_index (_tmp49_, (gint) (*source).index);
					_tmp50_ = _data8_->device;
					_tmp51_ = (*source).name;
					_tmp52_ = self->priv->default_source_name;
					sound_device_set_is_default (_tmp50_, g_strcmp0 (_tmp51_, _tmp52_) == 0);
					_tmp54_ = _data8_->device;
					_tmp55_ = sound_device_get_is_default (_tmp54_);
					_tmp56_ = _tmp55_;
					if (_tmp56_) {
						_tmp53_ = "true";
					} else {
						_tmp53_ = "false";
					}
					g_debug ("PulseAudioManager.vala:475: \t\t\tis_default: %s", _tmp53_);
					_tmp57_ = _data8_->device;
					sound_device_set_is_muted (_tmp57_, (*source).mute != 0);
					_tmp58_ = _data8_->device;
					_tmp59_ = (*source).volume;
					_tmp58_->cvolume = _tmp59_;
					_tmp60_ = _data8_->device;
					_tmp61_ = (*source).channel_map;
					_tmp60_->channel_map = _tmp61_;
					_tmp62_ = _data8_->device;
					_tmp63_ = (*source).channel_map;
					sound_device_set_balance (_tmp62_, pa_cvolume_get_balance (&(*source).volume, &_tmp63_));
					_tmp64_ = _data8_->device;
					_tmp65_ = _tmp64_->volume_operations;
					gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp65_, _______lambda8__gee_forall_func, _data8_);
					_tmp66_ = _data8_->device;
					_tmp67_ = _tmp66_->volume_operations;
					_tmp68_ = gee_collection_get_is_empty ((GeeCollection*) _tmp67_);
					_tmp69_ = _tmp68_;
					if (_tmp69_) {
						SoundDevice* _tmp70_;
						_tmp70_ = _data8_->device;
						sound_device_set_volume (_tmp70_, sound_pulse_audio_manager_volume_to_double (pa_cvolume_max (&(*source).volume)));
					}
					_tmp71_ = _data8_->device;
					_tmp72_ = sound_device_get_is_default (_tmp71_);
					_tmp73_ = _tmp72_;
					if (_tmp73_) {
						SoundDevice* _tmp74_;
						_tmp74_ = _data8_->device;
						sound_pulse_audio_manager_set_default_input (self, _tmp74_);
					}
				} else {
					SoundDevice* _tmp75_;
					SoundDevice* _tmp76_;
					SoundDevice* _tmp77_;
					_tmp75_ = _data8_->device;
					sound_device_set_source_name (_tmp75_, NULL);
					_tmp76_ = _data8_->device;
					sound_device_set_source_index (_tmp76_, -1);
					_tmp77_ = _data8_->device;
					sound_device_set_is_default (_tmp77_, FALSE);
				}
			}
			block8_data_unref (_data8_);
			_data8_ = NULL;
		}
		_g_object_unref0 (_device_it);
	}
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
	g_atomic_int_inc (&_data9_->_ref_count_);
	return _data9_;
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
		SoundPulseAudioManager* self;
		self = _data9_->self;
		_g_object_unref0 (_data9_->device);
		_g_object_unref0 (self);
		g_slice_free (Block9Data, _data9_);
	}
}

static gboolean
______lambda5_ (Block9Data* _data9_,
                pa_operation* operation)
{
	SoundPulseAudioManager* self;
	gboolean result = FALSE;
	self = _data9_->self;
	g_return_val_if_fail (operation != NULL, FALSE);
	if (pa_operation_get_state (operation) != PA_OPERATION_RUNNING) {
		SoundDevice* _tmp0_;
		GeeLinkedList* _tmp1_;
		_tmp0_ = _data9_->device;
		_tmp1_ = _tmp0_->volume_operations;
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, operation);
	}
	result = G_SOURCE_CONTINUE;
	_pa_operation_unref0 (operation);
	return result;
}

static gboolean
_______lambda5__gee_forall_func (gpointer g,
                                 gpointer self)
{
	gboolean result;
	result = ______lambda5_ (self, (pa_operation*) g);
	return result;
}

static void
sound_pulse_audio_manager_sink_info_callback (SoundPulseAudioManager* self,
                                              pa_context* c,
                                              pa_sink_info* sink,
                                              gint eol)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	pa_sink_port_info* _tmp8_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	if (sink == NULL) {
		return;
	}
	g_debug ("PulseAudioManager.vala:511: sink info update");
	_tmp0_ = (*sink).description;
	_tmp1_ = (*sink).name;
	g_debug ("PulseAudioManager.vala:512: \tsink: %s (%s)", _tmp0_, _tmp1_);
	_tmp2_ = (*sink).name;
	if (g_strcmp0 (_tmp2_, "auto_null") == 0) {
		return;
	}
	g_debug ("PulseAudioManager.vala:518: \t\tcard: %u", (guint) (*sink).card);
	if (sound_pulse_audio_manager_debug_enabled) {
		pa_sink_port_info** _tmp3_;
		gint _tmp3__length1;
		_tmp3_ = (*sink).ports;
		_tmp3__length1 = (*sink).n_ports;
		{
			pa_sink_port_info** port_collection = NULL;
			gint port_collection_length1 = 0;
			gint _port_collection_size_ = 0;
			gint port_it = 0;
			port_collection = _tmp3_;
			port_collection_length1 = _tmp3__length1;
			for (port_it = 0; port_it < port_collection_length1; port_it = port_it + 1) {
				pa_sink_port_info* port = NULL;
				port = port_collection[port_it];
				{
					pa_sink_port_info* _tmp4_;
					const gchar* _tmp5_;
					pa_sink_port_info* _tmp6_;
					const gchar* _tmp7_;
					_tmp4_ = port;
					_tmp5_ = (*_tmp4_).description;
					_tmp6_ = port;
					_tmp7_ = (*_tmp6_).name;
					g_debug ("PulseAudioManager.vala:522: \t\tport: %s (%s)", _tmp5_, _tmp7_);
				}
			}
		}
	}
	_tmp8_ = (*sink).active_port;
	if (_tmp8_ != NULL) {
		pa_sink_port_info* _tmp9_;
		const gchar* _tmp10_;
		pa_sink_port_info* _tmp11_;
		const gchar* _tmp12_;
		_tmp9_ = (*sink).active_port;
		_tmp10_ = (*_tmp9_).description;
		_tmp11_ = (*sink).active_port;
		_tmp12_ = (*_tmp11_).name;
		g_debug ("PulseAudioManager.vala:528: \t\tactive port: %s (%s)", _tmp10_, _tmp12_);
	}
	{
		GeeIterator* _device_it = NULL;
		GeeHashMap* _tmp13_;
		GeeCollection* _tmp14_;
		GeeCollection* _tmp15_;
		GeeCollection* _tmp16_;
		GeeIterator* _tmp17_;
		GeeIterator* _tmp18_;
		_tmp13_ = self->priv->output_devices;
		_tmp14_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = _tmp15_;
		_tmp17_ = gee_iterable_iterator ((GeeIterable*) _tmp16_);
		_tmp18_ = _tmp17_;
		_g_object_unref0 (_tmp16_);
		_device_it = _tmp18_;
		while (TRUE) {
			Block9Data* _data9_;
			GeeIterator* _tmp19_;
			GeeIterator* _tmp20_;
			gpointer _tmp21_;
			SoundDevice* _tmp22_;
			guint32 _tmp23_;
			guint32 _tmp24_;
			_data9_ = g_slice_new0 (Block9Data);
			_data9_->_ref_count_ = 1;
			_data9_->self = g_object_ref (self);
			_tmp19_ = _device_it;
			if (!gee_iterator_next (_tmp19_)) {
				block9_data_unref (_data9_);
				_data9_ = NULL;
				break;
			}
			_tmp20_ = _device_it;
			_tmp21_ = gee_iterator_get (_tmp20_);
			_data9_->device = (SoundDevice*) _tmp21_;
			_tmp22_ = _data9_->device;
			_tmp23_ = sound_device_get_card_index (_tmp22_);
			_tmp24_ = _tmp23_;
			if (_tmp24_ == (*sink).card) {
				SoundDevice* _tmp25_;
				const gchar* _tmp26_;
				const gchar* _tmp27_;
				SoundDevice* _tmp28_;
				SoundDevice* _tmp29_;
				const gchar* _tmp30_;
				SoundDevice* _tmp31_;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
				gboolean _tmp34_ = FALSE;
				pa_sink_port_info* _tmp35_;
				_tmp25_ = _data9_->device;
				_tmp26_ = sound_device_get_id (_tmp25_);
				_tmp27_ = _tmp26_;
				g_debug ("PulseAudioManager.vala:533: \t\tupdating device: %s", _tmp27_);
				_tmp28_ = _data9_->device;
				sound_device_set_card_sink_index (_tmp28_, (gint) (*sink).index);
				_tmp29_ = _data9_->device;
				_tmp30_ = (*sink).name;
				sound_device_set_card_sink_name (_tmp29_, _tmp30_);
				_tmp31_ = _data9_->device;
				_tmp32_ = sound_device_get_card_sink_name (_tmp31_);
				_tmp33_ = _tmp32_;
				g_debug ("PulseAudioManager.vala:536: \t\t\tdevice.card_sink_name: %s", _tmp33_);
				_tmp35_ = (*sink).active_port;
				if (_tmp35_ != NULL) {
					SoundDevice* _tmp36_;
					const gchar* _tmp37_;
					const gchar* _tmp38_;
					pa_sink_port_info* _tmp39_;
					const gchar* _tmp40_;
					_tmp36_ = _data9_->device;
					_tmp37_ = sound_device_get_port_name (_tmp36_);
					_tmp38_ = _tmp37_;
					_tmp39_ = (*sink).active_port;
					_tmp40_ = (*_tmp39_).name;
					_tmp34_ = g_strcmp0 (_tmp38_, _tmp40_) == 0;
				} else {
					_tmp34_ = FALSE;
				}
				if (_tmp34_) {
					SoundDevice* _tmp41_;
					pa_sink_port_info* _tmp42_;
					const gchar* _tmp43_;
					SoundDevice* _tmp44_;
					const gchar* _tmp45_;
					SoundDevice* _tmp46_;
					const gchar* _tmp47_;
					const gchar* _tmp48_;
					SoundDevice* _tmp49_;
					SoundDevice* _tmp50_;
					const gchar* _tmp51_;
					const gchar* _tmp52_;
					const gchar* _tmp53_ = NULL;
					SoundDevice* _tmp54_;
					gboolean _tmp55_;
					gboolean _tmp56_;
					SoundDevice* _tmp57_;
					SoundDevice* _tmp58_;
					pa_cvolume _tmp59_;
					SoundDevice* _tmp60_;
					pa_channel_map _tmp61_;
					SoundDevice* _tmp62_;
					pa_channel_map _tmp63_;
					SoundDevice* _tmp64_;
					GeeLinkedList* _tmp65_;
					SoundDevice* _tmp66_;
					GeeLinkedList* _tmp67_;
					gboolean _tmp68_;
					gboolean _tmp69_;
					SoundDevice* _tmp71_;
					gboolean _tmp72_;
					gboolean _tmp73_;
					_tmp41_ = _data9_->device;
					_tmp42_ = (*sink).active_port;
					_tmp43_ = (*_tmp42_).name;
					sound_device_set_card_sink_port_name (_tmp41_, _tmp43_);
					_tmp44_ = _data9_->device;
					_tmp45_ = (*sink).name;
					sound_device_set_sink_name (_tmp44_, _tmp45_);
					_tmp46_ = _data9_->device;
					_tmp47_ = sound_device_get_card_sink_name (_tmp46_);
					_tmp48_ = _tmp47_;
					g_debug ("PulseAudioManager.vala:541: \t\t\tdevice.sink_name: %s", _tmp48_);
					_tmp49_ = _data9_->device;
					sound_device_set_sink_index (_tmp49_, (gint) (*sink).index);
					_tmp50_ = _data9_->device;
					_tmp51_ = (*sink).name;
					_tmp52_ = self->priv->default_sink_name;
					sound_device_set_is_default (_tmp50_, g_strcmp0 (_tmp51_, _tmp52_) == 0);
					_tmp54_ = _data9_->device;
					_tmp55_ = sound_device_get_is_default (_tmp54_);
					_tmp56_ = _tmp55_;
					if (_tmp56_) {
						_tmp53_ = "true";
					} else {
						_tmp53_ = "false";
					}
					g_debug ("PulseAudioManager.vala:544: \t\t\tis_default: %s", _tmp53_);
					_tmp57_ = _data9_->device;
					sound_device_set_is_muted (_tmp57_, (*sink).mute != 0);
					_tmp58_ = _data9_->device;
					_tmp59_ = (*sink).volume;
					_tmp58_->cvolume = _tmp59_;
					_tmp60_ = _data9_->device;
					_tmp61_ = (*sink).channel_map;
					_tmp60_->channel_map = _tmp61_;
					_tmp62_ = _data9_->device;
					_tmp63_ = (*sink).channel_map;
					sound_device_set_balance (_tmp62_, pa_cvolume_get_balance (&(*sink).volume, &_tmp63_));
					_tmp64_ = _data9_->device;
					_tmp65_ = _tmp64_->volume_operations;
					gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp65_, _______lambda5__gee_forall_func, _data9_);
					_tmp66_ = _data9_->device;
					_tmp67_ = _tmp66_->volume_operations;
					_tmp68_ = gee_collection_get_is_empty ((GeeCollection*) _tmp67_);
					_tmp69_ = _tmp68_;
					if (_tmp69_) {
						SoundDevice* _tmp70_;
						_tmp70_ = _data9_->device;
						sound_device_set_volume (_tmp70_, sound_pulse_audio_manager_volume_to_double (pa_cvolume_max (&(*sink).volume)));
					}
					_tmp71_ = _data9_->device;
					_tmp72_ = sound_device_get_is_default (_tmp71_);
					_tmp73_ = _tmp72_;
					if (_tmp73_) {
						SoundDevice* _tmp74_;
						_tmp74_ = _data9_->device;
						sound_pulse_audio_manager_set_default_output (self, _tmp74_);
					}
				} else {
					SoundDevice* _tmp75_;
					SoundDevice* _tmp76_;
					SoundDevice* _tmp77_;
					_tmp75_ = _data9_->device;
					sound_device_set_sink_name (_tmp75_, NULL);
					_tmp76_ = _data9_->device;
					sound_device_set_sink_index (_tmp76_, -1);
					_tmp77_ = _data9_->device;
					sound_device_set_is_default (_tmp77_, FALSE);
				}
			}
			block9_data_unref (_data9_);
			_data9_ = NULL;
		}
		_g_object_unref0 (_device_it);
	}
}

static void
_vala_array_add1 (pa_card_port_info** * array,
                  gint* length,
                  gint* size,
                  pa_card_port_info* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (pa_card_port_info*, *array, *size);
	}
	(*array)[(*length)++] = value;
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static void
sound_pulse_audio_manager_card_info_callback (SoundPulseAudioManager* self,
                                              pa_context* c,
                                              pa_card_info* card,
                                              gint eol)
{
	pa_proplist* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	pa_card_profile_info2* _tmp3_;
	const gchar* _tmp4_;
	pa_proplist* _tmp5_;
	const gchar* _tmp6_;
	pa_proplist* _tmp7_;
	const gchar* _tmp8_;
	gchar* card_active_profile_name = NULL;
	pa_card_profile_info2* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	pa_card_port_info** relevant_ports = NULL;
	pa_card_port_info** _tmp12_;
	gint relevant_ports_length1;
	gint _relevant_ports_size_;
	pa_card_port_info** _tmp13_;
	gint _tmp13__length1;
	pa_card_port_info** _tmp17_;
	gint _tmp17__length1;
	GeeHashMap* _tmp86_;
	pa_card_port_info** _tmp87_;
	gint _tmp87__length1;
	pa_card_info _tmp88_;
	GeeHashMap* _tmp89_;
	pa_card_port_info** _tmp90_;
	gint _tmp90__length1;
	pa_card_info _tmp91_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	if (card == NULL) {
		return;
	}
	g_debug ("PulseAudioManager.vala:579: card info update");
	_tmp0_ = (*card).proplist;
	_tmp1_ = pa_proplist_gets (_tmp0_, PA_PROP_DEVICE_DESCRIPTION);
	_tmp2_ = (*card).name;
	g_debug ("PulseAudioManager.vala:580: \tcard: %u %s (%s)", (guint) (*card).index, _tmp1_, _tmp2_);
	_tmp3_ = (*card).active_profile2;
	_tmp4_ = (*_tmp3_).name;
	g_debug ("PulseAudioManager.vala:581: \t\tactive profile: %s", _tmp4_);
	_tmp5_ = (*card).proplist;
	_tmp6_ = pa_proplist_gets (_tmp5_, PA_PROP_DEVICE_FORM_FACTOR);
	g_debug ("PulseAudioManager.vala:583: \t\tcard form factor: %s", _tmp6_);
	_tmp7_ = (*card).proplist;
	_tmp8_ = pa_proplist_gets (_tmp7_, PA_PROP_MEDIA_ICON_NAME);
	g_debug ("PulseAudioManager.vala:584: \t\tcard icon name: %s", _tmp8_);
	_tmp9_ = (*card).active_profile2;
	_tmp10_ = (*_tmp9_).name;
	_tmp11_ = g_strdup (_tmp10_);
	card_active_profile_name = _tmp11_;
	_tmp12_ = g_new0 (pa_card_port_info*, 0);
	relevant_ports = _tmp12_;
	relevant_ports_length1 = 0;
	_relevant_ports_size_ = relevant_ports_length1;
	_tmp13_ = (*card).ports;
	_tmp13__length1 = (*card).n_ports;
	{
		pa_card_port_info** port_collection = NULL;
		gint port_collection_length1 = 0;
		gint _port_collection_size_ = 0;
		gint port_it = 0;
		port_collection = _tmp13_;
		port_collection_length1 = _tmp13__length1;
		for (port_it = 0; port_it < port_collection_length1; port_it = port_it + 1) {
			pa_card_port_info* port = NULL;
			port = port_collection[port_it];
			{
				pa_card_port_info* _tmp14_;
				pa_port_available_t _tmp15_;
				pa_card_port_info* _tmp16_;
				_tmp14_ = port;
				_tmp15_ = (*_tmp14_).available;
				if (_tmp15_ == PA_PORT_AVAILABLE_NO) {
					continue;
				}
				_tmp16_ = port;
				_vala_array_add1 (&relevant_ports, &relevant_ports_length1, &_relevant_ports_size_, _tmp16_);
			}
		}
	}
	_tmp17_ = relevant_ports;
	_tmp17__length1 = relevant_ports_length1;
	{
		pa_card_port_info** port_collection = NULL;
		gint port_collection_length1 = 0;
		gint _port_collection_size_ = 0;
		gint port_it = 0;
		port_collection = _tmp17_;
		port_collection_length1 = _tmp17__length1;
		for (port_it = 0; port_it < port_collection_length1; port_it = port_it + 1) {
			pa_card_port_info* port = NULL;
			port = port_collection[port_it];
			{
				gboolean is_input = FALSE;
				pa_card_port_info* _tmp18_;
				pa_direction_t _tmp19_;
				const gchar* _tmp20_ = NULL;
				pa_card_port_info* _tmp21_;
				const gchar* _tmp22_;
				pa_card_port_info* _tmp23_;
				const gchar* _tmp24_;
				GeeHashMap* _tmp25_ = NULL;
				GeeHashMap* devices = NULL;
				GeeHashMap* _tmp28_;
				SoundDevice* device = NULL;
				gchar* id = NULL;
				pa_card_port_info* _tmp29_;
				pa_card_info _tmp30_;
				gchar* _tmp31_;
				gboolean is_new = FALSE;
				GeeHashMap* _tmp32_;
				const gchar* _tmp33_;
				SoundDevice* _tmp43_;
				const gchar* _tmp44_;
				SoundDevice* _tmp45_;
				SoundDevice* _tmp46_;
				const gchar* _tmp47_;
				gchar* card_description = NULL;
				pa_proplist* _tmp48_;
				const gchar* _tmp49_;
				gchar* _tmp50_;
				SoundDevice* _tmp51_;
				pa_card_port_info* _tmp52_;
				const gchar* _tmp53_;
				const gchar* _tmp54_;
				const gchar* _tmp55_;
				const gchar* _tmp56_;
				gchar* _tmp57_;
				gchar* _tmp58_;
				SoundDevice* _tmp59_;
				pa_card_port_info* _tmp60_;
				pa_proplist* _tmp61_;
				const gchar* _tmp62_;
				pa_card_port_info* _tmp63_;
				pa_proplist* _tmp64_;
				const gchar* _tmp65_;
				SoundDevice* _tmp66_;
				pa_card_port_info* _tmp67_;
				GeeArrayList* _tmp68_;
				GeeArrayList* _tmp69_;
				_tmp18_ = port;
				_tmp19_ = (*_tmp18_).direction;
				is_input = (_tmp19_ & PA_DIRECTION_INPUT) == PA_DIRECTION_INPUT;
				if (is_input) {
					_tmp20_ = "input";
				} else {
					_tmp20_ = "output";
				}
				_tmp21_ = port;
				_tmp22_ = (*_tmp21_).description;
				_tmp23_ = port;
				_tmp24_ = (*_tmp23_).name;
				g_debug ("PulseAudioManager.vala:601: \t\t%s port: %s (%s)", _tmp20_, _tmp22_, _tmp24_);
				if (is_input) {
					GeeHashMap* _tmp26_;
					_tmp26_ = self->priv->input_devices;
					_tmp25_ = _tmp26_;
				} else {
					GeeHashMap* _tmp27_;
					_tmp27_ = self->priv->output_devices;
					_tmp25_ = _tmp27_;
				}
				_tmp28_ = _g_object_ref0 (_tmp25_);
				devices = _tmp28_;
				device = NULL;
				_tmp29_ = port;
				_tmp30_ = *card;
				_tmp31_ = sound_pulse_audio_manager_get_device_id (&_tmp30_, _tmp29_);
				id = _tmp31_;
				_tmp32_ = devices;
				_tmp33_ = id;
				is_new = !gee_abstract_map_has_key ((GeeAbstractMap*) _tmp32_, _tmp33_);
				if (is_new) {
					const gchar* _tmp34_;
					const gchar* _tmp35_;
					pa_card_port_info* _tmp36_;
					const gchar* _tmp37_;
					SoundDevice* _tmp38_;
					_tmp34_ = id;
					g_debug ("PulseAudioManager.vala:607: \t\t\tnew device: %s", _tmp34_);
					_tmp35_ = id;
					_tmp36_ = port;
					_tmp37_ = (*_tmp36_).name;
					_tmp38_ = sound_device_new (_tmp35_, (*card).index, _tmp37_);
					_g_object_unref0 (device);
					device = _tmp38_;
				} else {
					const gchar* _tmp39_;
					GeeHashMap* _tmp40_;
					const gchar* _tmp41_;
					gpointer _tmp42_;
					_tmp39_ = id;
					g_debug ("PulseAudioManager.vala:610: \t\t\tupdating device: %s", _tmp39_);
					_tmp40_ = devices;
					_tmp41_ = id;
					_tmp42_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp40_, _tmp41_);
					_g_object_unref0 (device);
					device = (SoundDevice*) _tmp42_;
				}
				_tmp43_ = device;
				_tmp44_ = card_active_profile_name;
				sound_device_set_card_active_profile_name (_tmp43_, _tmp44_);
				_tmp45_ = device;
				sound_device_set_input (_tmp45_, is_input);
				_tmp46_ = device;
				_tmp47_ = (*card).name;
				sound_device_set_card_name (_tmp46_, _tmp47_);
				_tmp48_ = (*card).proplist;
				_tmp49_ = pa_proplist_gets (_tmp48_, PA_PROP_DEVICE_DESCRIPTION);
				_tmp50_ = g_strdup (_tmp49_);
				card_description = _tmp50_;
				_tmp51_ = device;
				_tmp52_ = port;
				_tmp53_ = (*_tmp52_).description;
				_tmp54_ = string_to_string (_tmp53_);
				_tmp55_ = card_description;
				_tmp56_ = string_to_string (_tmp55_);
				_tmp57_ = g_strconcat (_tmp54_, " - ", _tmp56_, NULL);
				_tmp58_ = _tmp57_;
				sound_device_set_display_name (_tmp51_, _tmp58_);
				_g_free0 (_tmp58_);
				_tmp59_ = device;
				_tmp60_ = port;
				_tmp61_ = (*_tmp60_).proplist;
				_tmp62_ = pa_proplist_gets (_tmp61_, PA_PROP_DEVICE_FORM_FACTOR);
				sound_device_set_form_factor (_tmp59_, _tmp62_);
				_tmp63_ = port;
				_tmp64_ = (*_tmp63_).proplist;
				_tmp65_ = pa_proplist_gets (_tmp64_, PA_PROP_MEDIA_ICON_NAME);
				g_debug ("PulseAudioManager.vala:620: \t\t\tport icon name: %s", _tmp65_);
				_tmp66_ = device;
				_tmp67_ = port;
				_tmp68_ = sound_pulse_audio_manager_get_relevant_card_port_profiles (self, _tmp67_);
				_tmp69_ = _tmp68_;
				sound_device_set_profiles (_tmp66_, _tmp69_);
				_g_object_unref0 (_tmp69_);
				if (sound_pulse_audio_manager_debug_enabled) {
					{
						GeeArrayList* _profile_list = NULL;
						SoundDevice* _tmp70_;
						GeeArrayList* _tmp71_;
						GeeArrayList* _tmp72_;
						GeeArrayList* _tmp73_;
						gint _profile_size = 0;
						GeeArrayList* _tmp74_;
						gint _tmp75_;
						gint _tmp76_;
						gint _profile_index = 0;
						_tmp70_ = device;
						_tmp71_ = sound_device_get_profiles (_tmp70_);
						_tmp72_ = _tmp71_;
						_tmp73_ = _g_object_ref0 (_tmp72_);
						_profile_list = _tmp73_;
						_tmp74_ = _profile_list;
						_tmp75_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp74_);
						_tmp76_ = _tmp75_;
						_profile_size = _tmp76_;
						_profile_index = -1;
						while (TRUE) {
							gint _tmp77_;
							gint _tmp78_;
							gchar* profile = NULL;
							GeeArrayList* _tmp79_;
							gpointer _tmp80_;
							const gchar* _tmp81_;
							_profile_index = _profile_index + 1;
							_tmp77_ = _profile_index;
							_tmp78_ = _profile_size;
							if (!(_tmp77_ < _tmp78_)) {
								break;
							}
							_tmp79_ = _profile_list;
							_tmp80_ = gee_abstract_list_get ((GeeAbstractList*) _tmp79_, _profile_index);
							profile = (gchar*) _tmp80_;
							_tmp81_ = profile;
							g_debug ("PulseAudioManager.vala:624: \t\t\tprofile: %s", _tmp81_);
							_g_free0 (profile);
						}
						_g_object_unref0 (_profile_list);
					}
				}
				if (is_new) {
					GeeHashMap* _tmp82_;
					const gchar* _tmp83_;
					SoundDevice* _tmp84_;
					SoundDevice* _tmp85_;
					_tmp82_ = devices;
					_tmp83_ = id;
					_tmp84_ = device;
					gee_abstract_map_set ((GeeAbstractMap*) _tmp82_, _tmp83_, _tmp84_);
					_tmp85_ = device;
					g_signal_emit (self, sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL], 0, _tmp85_);
				}
				_g_free0 (card_description);
				_g_free0 (id);
				_g_object_unref0 (device);
				_g_object_unref0 (devices);
			}
		}
	}
	_tmp86_ = self->priv->output_devices;
	_tmp87_ = relevant_ports;
	_tmp87__length1 = relevant_ports_length1;
	_tmp88_ = *card;
	sound_pulse_audio_manager_cleanup_devices (self, _tmp86_, &_tmp88_, _tmp87_, (gint) _tmp87__length1);
	_tmp89_ = self->priv->input_devices;
	_tmp90_ = relevant_ports;
	_tmp90__length1 = relevant_ports_length1;
	_tmp91_ = *card;
	sound_pulse_audio_manager_cleanup_devices (self, _tmp89_, &_tmp91_, _tmp90_, (gint) _tmp90__length1);
	relevant_ports = (g_free (relevant_ports), NULL);
	_g_free0 (card_active_profile_name);
}

static void
sound_pulse_audio_manager_cleanup_devices (SoundPulseAudioManager* self,
                                           GeeHashMap* devices,
                                           pa_card_info* card,
                                           pa_card_port_info** relevant_ports,
                                           gint relevant_ports_length1)
{
	GeeMapIterator* iter = NULL;
	GeeMapIterator* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (devices != NULL);
	g_return_if_fail (card != NULL);
	_tmp0_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) devices);
	iter = _tmp0_;
	while (TRUE) {
		GeeMapIterator* _tmp1_;
		SoundDevice* device = NULL;
		GeeMapIterator* _tmp2_;
		gpointer _tmp3_;
		SoundDevice* _tmp4_;
		guint32 _tmp5_;
		guint32 _tmp6_;
		pa_card_info _tmp7_;
		gboolean found = FALSE;
		_tmp1_ = iter;
		if (!gee_map_iterator_next (_tmp1_)) {
			break;
		}
		_tmp2_ = iter;
		_tmp3_ = gee_map_iterator_get_value (_tmp2_);
		device = (SoundDevice*) _tmp3_;
		_tmp4_ = device;
		_tmp5_ = sound_device_get_card_index (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = *card;
		if (_tmp6_ != _tmp7_.index) {
			_g_object_unref0 (device);
			continue;
		}
		found = FALSE;
		{
			pa_card_port_info** port_collection = NULL;
			gint port_collection_length1 = 0;
			gint _port_collection_size_ = 0;
			gint port_it = 0;
			port_collection = relevant_ports;
			port_collection_length1 = relevant_ports_length1;
			for (port_it = 0; port_it < port_collection_length1; port_it = port_it + 1) {
				pa_card_port_info* port = NULL;
				port = port_collection[port_it];
				{
					SoundDevice* _tmp8_;
					const gchar* _tmp9_;
					const gchar* _tmp10_;
					pa_card_info _tmp11_;
					pa_card_port_info* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
					gboolean _tmp15_;
					_tmp8_ = device;
					_tmp9_ = sound_device_get_id (_tmp8_);
					_tmp10_ = _tmp9_;
					_tmp11_ = *card;
					_tmp12_ = port;
					_tmp13_ = sound_pulse_audio_manager_get_device_id (&_tmp11_, _tmp12_);
					_tmp14_ = _tmp13_;
					_tmp15_ = g_strcmp0 (_tmp10_, _tmp14_) == 0;
					_g_free0 (_tmp14_);
					if (_tmp15_) {
						found = TRUE;
						break;
					}
				}
			}
		}
		if (!found) {
			SoundDevice* _tmp16_;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
			SoundDevice* _tmp19_;
			GeeMapIterator* _tmp20_;
			_tmp16_ = device;
			_tmp17_ = sound_device_get_id (_tmp16_);
			_tmp18_ = _tmp17_;
			g_debug ("PulseAudioManager.vala:657: \t\tremoving device: %s", _tmp18_);
			_tmp19_ = device;
			g_signal_emit_by_name (_tmp19_, "removed");
			_tmp20_ = iter;
			gee_map_iterator_unset (_tmp20_);
		}
		_g_object_unref0 (device);
	}
	_g_object_unref0 (iter);
}

static gchar*
sound_pulse_audio_manager_get_device_id (pa_card_info* card,
                                         pa_card_port_info* port)
{
	pa_card_info _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result = NULL;
	g_return_val_if_fail (card != NULL, NULL);
	_tmp0_ = *card;
	_tmp1_ = _tmp0_.name;
	_tmp2_ = string_to_string (_tmp1_);
	_tmp3_ = (*port).name;
	_tmp4_ = string_to_string (_tmp3_);
	_tmp5_ = g_strconcat (_tmp2_, ":", _tmp4_, NULL);
	result = _tmp5_;
	return result;
}

static pa_card_profile_info2**
_vala_array_dup1 (pa_card_profile_info2** self,
                  gint length)
{
	if (length > 0) {
		return g_memdup (self, length * sizeof (pa_card_profile_info2*));
	}
	return NULL;
}

static gint
__lambda7_ (SoundPulseAudioManager* self,
            pa_card_profile_info2* a,
            pa_card_profile_info2* b)
{
	gint result = 0;
	if ((*a).priority > (*b).priority) {
		result = -1;
		return result;
	}
	if ((*a).priority < (*b).priority) {
		result = 1;
		return result;
	}
	result = 0;
	return result;
}

static gint
___lambda7__gcompare_data_func (gconstpointer a,
                                gconstpointer b,
                                gpointer self)
{
	gint result;
	result = __lambda7_ ((SoundPulseAudioManager*) self, a, b);
	return result;
}

static GeeArrayList*
sound_pulse_audio_manager_get_relevant_card_port_profiles (SoundPulseAudioManager* self,
                                                           pa_card_port_info* port)
{
	GeeArrayList* profiles_list = NULL;
	pa_card_profile_info2** _tmp0_;
	gint _tmp0__length1;
	pa_card_profile_info2** _tmp1_;
	gint _tmp1__length1;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* profiles = NULL;
	GeeArrayList* _tmp4_;
	GeeArrayList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = (*port).profiles2;
	_tmp0__length1 = (*port).n_profiles;
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup1 (_tmp0_, _tmp0__length1) : ((gpointer) _tmp0_);
	_tmp1__length1 = _tmp0__length1;
	_tmp2_ = gee_array_list_new_wrap (G_TYPE_POINTER, NULL, NULL, _tmp1_, _tmp1__length1, NULL, NULL, NULL);
	profiles_list = _tmp2_;
	_tmp3_ = profiles_list;
	gee_list_sort ((GeeList*) _tmp3_, ___lambda7__gcompare_data_func, g_object_ref (self), g_object_unref);
	_tmp4_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	profiles = _tmp4_;
	{
		GeeArrayList* _item_list = NULL;
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
		gint _item_size = 0;
		GeeArrayList* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _item_index = 0;
		_tmp5_ = profiles_list;
		_tmp6_ = _g_object_ref0 (_tmp5_);
		_item_list = _tmp6_;
		_tmp7_ = _item_list;
		_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
		_tmp9_ = _tmp8_;
		_item_size = _tmp9_;
		_item_index = -1;
		while (TRUE) {
			gint _tmp10_;
			gint _tmp11_;
			pa_card_profile_info2* item = NULL;
			GeeArrayList* _tmp12_;
			gpointer _tmp13_;
			GeeArrayList* _tmp14_;
			pa_card_profile_info2* _tmp15_;
			const gchar* _tmp16_;
			_item_index = _item_index + 1;
			_tmp10_ = _item_index;
			_tmp11_ = _item_size;
			if (!(_tmp10_ < _tmp11_)) {
				break;
			}
			_tmp12_ = _item_list;
			_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, _item_index);
			item = _tmp13_;
			_tmp14_ = profiles;
			_tmp15_ = item;
			_tmp16_ = (*_tmp15_).name;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp16_);
		}
		_g_object_unref0 (_item_list);
	}
	result = profiles;
	_g_object_unref0 (profiles_list);
	return result;
}

static void
sound_pulse_audio_manager_remove_devices_by_card (SoundPulseAudioManager* self,
                                                  GeeHashMap* devices,
                                                  guint32 card_index)
{
	GeeMapIterator* iter = NULL;
	GeeMapIterator* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (devices != NULL);
	_tmp0_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) devices);
	iter = _tmp0_;
	while (TRUE) {
		GeeMapIterator* _tmp1_;
		SoundDevice* device = NULL;
		GeeMapIterator* _tmp2_;
		gpointer _tmp3_;
		SoundDevice* _tmp4_;
		guint32 _tmp5_;
		guint32 _tmp6_;
		_tmp1_ = iter;
		if (!gee_map_iterator_next (_tmp1_)) {
			break;
		}
		_tmp2_ = iter;
		_tmp3_ = gee_map_iterator_get_value (_tmp2_);
		device = (SoundDevice*) _tmp3_;
		_tmp4_ = device;
		_tmp5_ = sound_device_get_card_index (_tmp4_);
		_tmp6_ = _tmp5_;
		if (_tmp6_ == card_index) {
			SoundDevice* _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			SoundDevice* _tmp10_;
			GeeMapIterator* _tmp11_;
			_tmp7_ = device;
			_tmp8_ = sound_device_get_id (_tmp7_);
			_tmp9_ = _tmp8_;
			g_debug ("PulseAudioManager.vala:698: removing device: %s", _tmp9_);
			_tmp10_ = device;
			g_signal_emit_by_name (_tmp10_, "removed");
			_tmp11_ = iter;
			gee_map_iterator_unset (_tmp11_);
		}
		_g_object_unref0 (device);
	}
	_g_object_unref0 (iter);
}

static void
_sound_pulse_audio_manager_ext_stream_restore_read_sink_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                         pa_ext_stream_restore_info* info,
                                                                                                         gint eol,
                                                                                                         gpointer self)
{
	sound_pulse_audio_manager_ext_stream_restore_read_sink_callback ((SoundPulseAudioManager*) self, c, info, eol);
}

static void
_sound_pulse_audio_manager_ext_stream_restore_read_source_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                           pa_ext_stream_restore_info* info,
                                                                                                           gint eol,
                                                                                                           gpointer self)
{
	sound_pulse_audio_manager_ext_stream_restore_read_source_callback ((SoundPulseAudioManager*) self, c, info, eol);
}

static void
sound_pulse_audio_manager_server_info_callback (SoundPulseAudioManager* self,
                                                pa_context* context,
                                                pa_server_info* server)
{
	const gchar* _tmp0_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp12_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	pa_operation* _tmp24_;
	pa_operation* _tmp25_;
	pa_operation* _tmp26_;
	pa_operation* _tmp27_;
	pa_operation* _tmp28_;
	pa_operation* _tmp29_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	g_debug ("PulseAudioManager.vala:706: server info update");
	if (server == NULL) {
		return;
	}
	_tmp0_ = self->priv->default_sink_name;
	if (_tmp0_ == NULL) {
		const gchar* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		_tmp1_ = (*server).default_sink_name;
		_tmp2_ = g_strdup (_tmp1_);
		_g_free0 (self->priv->default_sink_name);
		self->priv->default_sink_name = _tmp2_;
		_tmp3_ = self->priv->default_sink_name;
		g_debug ("PulseAudioManager.vala:713: \tdefault_sink_name: %s", _tmp3_);
	}
	_tmp4_ = self->priv->default_sink_name;
	_tmp5_ = (*server).default_sink_name;
	if (g_strcmp0 (_tmp4_, _tmp5_) != 0) {
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		pa_operation* _tmp10_;
		pa_operation* _tmp11_;
		_tmp6_ = self->priv->default_sink_name;
		_tmp7_ = (*server).default_sink_name;
		g_debug ("PulseAudioManager.vala:717: \tdefault_sink_name: %s > %s", _tmp6_, _tmp7_);
		_tmp8_ = (*server).default_sink_name;
		_tmp9_ = g_strdup (_tmp8_);
		_g_free0 (self->priv->default_sink_name);
		self->priv->default_sink_name = _tmp9_;
		_tmp10_ = pa_ext_stream_restore_read (context, _sound_pulse_audio_manager_ext_stream_restore_read_sink_callback_pulse_audio_ext_stream_restore_read_cb, self);
		_tmp11_ = _tmp10_;
		_pa_operation_unref0 (_tmp11_);
	}
	_tmp12_ = self->priv->default_source_name;
	if (_tmp12_ == NULL) {
		const gchar* _tmp13_;
		gchar* _tmp14_;
		const gchar* _tmp15_;
		_tmp13_ = (*server).default_source_name;
		_tmp14_ = g_strdup (_tmp13_);
		_g_free0 (self->priv->default_source_name);
		self->priv->default_source_name = _tmp14_;
		_tmp15_ = self->priv->default_source_name;
		g_debug ("PulseAudioManager.vala:724: \tdefault_source_name: %s", _tmp15_);
	}
	_tmp16_ = self->priv->default_source_name;
	_tmp17_ = (*server).default_source_name;
	if (g_strcmp0 (_tmp16_, _tmp17_) != 0) {
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		pa_operation* _tmp22_;
		pa_operation* _tmp23_;
		_tmp18_ = self->priv->default_source_name;
		_tmp19_ = (*server).default_source_name;
		g_debug ("PulseAudioManager.vala:728: \tdefault_source_name: %s > %s", _tmp18_, _tmp19_);
		_tmp20_ = (*server).default_source_name;
		_tmp21_ = g_strdup (_tmp20_);
		_g_free0 (self->priv->default_source_name);
		self->priv->default_source_name = _tmp21_;
		_tmp22_ = pa_ext_stream_restore_read (context, _sound_pulse_audio_manager_ext_stream_restore_read_source_callback_pulse_audio_ext_stream_restore_read_cb, self);
		_tmp23_ = _tmp22_;
		_pa_operation_unref0 (_tmp23_);
	}
	_tmp24_ = pa_context_get_card_info_list (context, _sound_pulse_audio_manager_card_info_callback_pa_card_info_cb_t, self);
	_tmp25_ = _tmp24_;
	_pa_operation_unref0 (_tmp25_);
	_tmp26_ = pa_context_get_source_info_list (context, _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t, self);
	_tmp27_ = _tmp26_;
	_pa_operation_unref0 (_tmp27_);
	_tmp28_ = pa_context_get_sink_info_list (context, _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t, self);
	_tmp29_ = _tmp28_;
	_pa_operation_unref0 (_tmp29_);
}

static void
__lambda6_ (SoundPulseAudioManager* self,
            pa_context* c,
            gint success)
{
	g_return_if_fail (c != NULL);
	if (success != 1) {
		g_warning ("PulseAudioManager.vala:758: Updating source failed");
	}
}

static void
___lambda6__pa_context_success_cb_t (pa_context* c,
                                     gint success,
                                     gpointer self)
{
	__lambda6_ ((SoundPulseAudioManager*) self, c, success);
}

static void
sound_pulse_audio_manager_ext_stream_restore_read_sink_callback (SoundPulseAudioManager* self,
                                                                 pa_context* c,
                                                                 pa_ext_stream_restore_info* info,
                                                                 gint eol)
{
	gboolean _tmp0_ = FALSE;
	pa_ext_stream_restore_info new_info = {0};
	const gchar* _tmp2_;
	pa_channel_map _tmp3_;
	pa_cvolume _tmp4_;
	const gchar* _tmp5_;
	pa_ext_stream_restore_info _tmp6_;
	pa_ext_stream_restore_info* _tmp7_;
	pa_ext_stream_restore_info* _tmp8_;
	gint _tmp8__length1;
	pa_operation* _tmp9_;
	pa_operation* _tmp10_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	if (eol != 0) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp1_;
		_tmp1_ = (*info).name;
		_tmp0_ = !g_str_has_prefix (_tmp1_, "sink-input-by");
	}
	if (_tmp0_) {
		return;
	}
	memset (&new_info, 0, sizeof (pa_ext_stream_restore_info));
	_tmp2_ = (*info).name;
	new_info.name = _tmp2_;
	_tmp3_ = (*info).channel_map;
	new_info.channel_map = _tmp3_;
	_tmp4_ = (*info).volume;
	new_info.volume = _tmp4_;
	new_info.mute = (*info).mute;
	_tmp5_ = self->priv->default_sink_name;
	new_info.device = _tmp5_;
	_tmp6_ = new_info;
	_tmp7_ = g_new0 (pa_ext_stream_restore_info, 1);
	_tmp7_[0] = _tmp6_;
	_tmp8_ = _tmp7_;
	_tmp8__length1 = 1;
	_tmp9_ = pa_ext_stream_restore_write (c, PA_UPDATE_REPLACE, _tmp8_, (gint) 1, 1, ___lambda6__pa_context_success_cb_t, self);
	_tmp10_ = _tmp9_;
	_pa_operation_unref0 (_tmp10_);
	_tmp8_ = (g_free (_tmp8_), NULL);
}

static void
sound_pulse_audio_manager_ext_stream_restore_read_source_callback (SoundPulseAudioManager* self,
                                                                   pa_context* c,
                                                                   pa_ext_stream_restore_info* info,
                                                                   gint eol)
{
	gboolean _tmp0_ = FALSE;
	pa_ext_stream_restore_info new_info = {0};
	const gchar* _tmp2_;
	pa_channel_map _tmp3_;
	pa_cvolume _tmp4_;
	const gchar* _tmp5_;
	pa_ext_stream_restore_info _tmp6_;
	pa_ext_stream_restore_info* _tmp7_;
	pa_ext_stream_restore_info* _tmp8_;
	gint _tmp8__length1;
	pa_operation* _tmp9_;
	pa_operation* _tmp10_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	if (eol != 0) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp1_;
		_tmp1_ = (*info).name;
		_tmp0_ = !g_str_has_prefix (_tmp1_, "source-output-by");
	}
	if (_tmp0_) {
		return;
	}
	memset (&new_info, 0, sizeof (pa_ext_stream_restore_info));
	_tmp2_ = (*info).name;
	new_info.name = _tmp2_;
	_tmp3_ = (*info).channel_map;
	new_info.channel_map = _tmp3_;
	_tmp4_ = (*info).volume;
	new_info.volume = _tmp4_;
	new_info.mute = (*info).mute;
	_tmp5_ = self->priv->default_source_name;
	new_info.device = _tmp5_;
	_tmp6_ = new_info;
	_tmp7_ = g_new0 (pa_ext_stream_restore_info, 1);
	_tmp7_[0] = _tmp6_;
	_tmp8_ = _tmp7_;
	_tmp8__length1 = 1;
	_tmp9_ = pa_ext_stream_restore_write (c, PA_UPDATE_REPLACE, _tmp8_, (gint) 1, 1, NULL, NULL);
	_tmp10_ = _tmp9_;
	_pa_operation_unref0 (_tmp10_);
	_tmp8_ = (g_free (_tmp8_), NULL);
}

static gdouble
sound_pulse_audio_manager_volume_to_double (pa_volume_t vol)
{
	gdouble tmp = 0.0;
	gdouble result = 0.0;
	tmp = (gdouble) (vol - PA_VOLUME_MUTED);
	result = (100 * tmp) / ((gdouble) (PA_VOLUME_NORM - PA_VOLUME_MUTED));
	return result;
}

static pa_volume_t
sound_pulse_audio_manager_double_to_volume (gdouble vol)
{
	gdouble tmp = 0.0;
	pa_volume_t result = 0U;
	tmp = (((gdouble) (PA_VOLUME_NORM - PA_VOLUME_MUTED)) * vol) / 100;
	result = ((pa_volume_t) tmp) + PA_VOLUME_MUTED;
	return result;
}

pa_context*
sound_pulse_audio_manager_get_context (SoundPulseAudioManager* self)
{
	pa_context* result;
	pa_context* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_context;
	result = _tmp0_;
	return result;
}

static gpointer
_pa_context_ref0 (gpointer self)
{
	return self ? pa_context_ref (self) : NULL;
}

static void
sound_pulse_audio_manager_set_context (SoundPulseAudioManager* self,
                                       pa_context* value)
{
	g_return_if_fail (self != NULL);
	if (sound_pulse_audio_manager_get_context (self) != value) {
		pa_context* _tmp0_;
		_tmp0_ = _pa_context_ref0 (value);
		_pa_context_unref0 (self->priv->_context);
		self->priv->_context = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY]);
	}
}

SoundDevice*
sound_pulse_audio_manager_get_default_output (SoundPulseAudioManager* self)
{
	SoundDevice* result;
	SoundDevice* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_default_output;
	result = _tmp0_;
	return result;
}

static void
sound_pulse_audio_manager_set_default_output (SoundPulseAudioManager* self,
                                              SoundDevice* value)
{
	g_return_if_fail (self != NULL);
	if (sound_pulse_audio_manager_get_default_output (self) != value) {
		SoundDevice* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_default_output);
		self->priv->_default_output = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY]);
	}
}

SoundDevice*
sound_pulse_audio_manager_get_default_input (SoundPulseAudioManager* self)
{
	SoundDevice* result;
	SoundDevice* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_default_input;
	result = _tmp0_;
	return result;
}

static void
sound_pulse_audio_manager_set_default_input (SoundPulseAudioManager* self,
                                             SoundDevice* value)
{
	g_return_if_fail (self != NULL);
	if (sound_pulse_audio_manager_get_default_input (self) != value) {
		SoundDevice* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_default_input);
		self->priv->_default_input = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY]);
	}
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gint stack_length,
                             const gchar* needle)
{
	gint i;
	for (i = 0; i < stack_length; i++) {
		if (g_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}

static GObject *
sound_pulse_audio_manager_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SoundPulseAudioManager * self;
	pa_glib_mainloop* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	GeeHashMap* _tmp3_;
	gchar* messages_debug_raw = NULL;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	parent_class = G_OBJECT_CLASS (sound_pulse_audio_manager_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
	_tmp0_ = pa_glib_mainloop_new (NULL);
	_pa_glib_mainloop_free0 (self->priv->loop);
	self->priv->loop = _tmp0_;
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, SOUND_TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->input_devices);
	self->priv->input_devices = _tmp1_;
	_tmp2_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, SOUND_TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->output_devices);
	self->priv->output_devices = _tmp2_;
	_tmp3_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, G_TYPE_POINTER, (GBoxedCopyFunc) pa_operation_ref, (GDestroyNotify) pa_operation_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->volume_operations);
	self->priv->volume_operations = _tmp3_;
	_tmp4_ = g_getenv ("G_MESSAGES_DEBUG");
	_tmp5_ = g_strdup (_tmp4_);
	messages_debug_raw = _tmp5_;
	_tmp6_ = messages_debug_raw;
	if (_tmp6_ != NULL) {
		gchar** messages_debug = NULL;
		const gchar* _tmp7_;
		gchar** _tmp8_;
		gchar** _tmp9_;
		gint messages_debug_length1;
		gint _messages_debug_size_;
		gboolean _tmp10_ = FALSE;
		gchar** _tmp11_;
		gint _tmp11__length1;
		_tmp7_ = messages_debug_raw;
		_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, " ", 0);
		messages_debug = _tmp9_;
		messages_debug_length1 = _vala_array_length (_tmp8_);
		_messages_debug_size_ = messages_debug_length1;
		_tmp11_ = messages_debug;
		_tmp11__length1 = messages_debug_length1;
		if (_vala_string_array_contains (_tmp11_, _tmp11__length1, "all")) {
			_tmp10_ = TRUE;
		} else {
			gchar** _tmp12_;
			gint _tmp12__length1;
			_tmp12_ = messages_debug;
			_tmp12__length1 = messages_debug_length1;
			_tmp10_ = _vala_string_array_contains (_tmp12_, _tmp12__length1, "debug");
		}
		sound_pulse_audio_manager_debug_enabled = _tmp10_;
		messages_debug = (_vala_array_free (messages_debug, messages_debug_length1, (GDestroyNotify) g_free), NULL);
	}
	_g_free0 (messages_debug_raw);
	return obj;
}

static void
sound_pulse_audio_manager_class_init (SoundPulseAudioManagerClass * klass,
                                      gpointer klass_data)
{
	sound_pulse_audio_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SoundPulseAudioManager_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_sound_pulse_audio_manager_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_sound_pulse_audio_manager_set_property;
	G_OBJECT_CLASS (klass)->constructor = sound_pulse_audio_manager_constructor;
	G_OBJECT_CLASS (klass)->finalize = sound_pulse_audio_manager_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY] = g_param_spec_pointer ("context", "context", "context", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY] = g_param_spec_object ("default-output", "default-output", "default-output", SOUND_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY] = g_param_spec_object ("default-input", "default-input", "default-input", SOUND_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL] = g_signal_new ("new-device", SOUND_TYPE_PULSE_AUDIO_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, SOUND_TYPE_DEVICE);
}

static void
sound_pulse_audio_manager_instance_init (SoundPulseAudioManager * self,
                                         gpointer klass)
{
	self->priv = sound_pulse_audio_manager_get_instance_private (self);
	self->priv->is_ready = FALSE;
	self->priv->reconnect_timer_id = 0U;
}

static void
sound_pulse_audio_manager_finalize (GObject * obj)
{
	SoundPulseAudioManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
	_pa_context_unref0 (self->priv->_context);
	_pa_glib_mainloop_free0 (self->priv->loop);
	_g_object_unref0 (self->priv->input_devices);
	_g_object_unref0 (self->priv->output_devices);
	_g_object_unref0 (self->priv->_default_output);
	_g_object_unref0 (self->priv->_default_input);
	_g_free0 (self->priv->default_source_name);
	_g_free0 (self->priv->default_sink_name);
	_g_object_unref0 (self->priv->volume_operations);
	G_OBJECT_CLASS (sound_pulse_audio_manager_parent_class)->finalize (obj);
}

static GType
sound_pulse_audio_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundPulseAudioManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_pulse_audio_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundPulseAudioManager), 0, (GInstanceInitFunc) sound_pulse_audio_manager_instance_init, NULL };
	GType sound_pulse_audio_manager_type_id;
	sound_pulse_audio_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "SoundPulseAudioManager", &g_define_type_info, 0);
	SoundPulseAudioManager_private_offset = g_type_add_instance_private (sound_pulse_audio_manager_type_id, sizeof (SoundPulseAudioManagerPrivate));
	return sound_pulse_audio_manager_type_id;
}

GType
sound_pulse_audio_manager_get_type (void)
{
	static volatile gsize sound_pulse_audio_manager_type_id__volatile = 0;
	if (g_once_init_enter (&sound_pulse_audio_manager_type_id__volatile)) {
		GType sound_pulse_audio_manager_type_id;
		sound_pulse_audio_manager_type_id = sound_pulse_audio_manager_get_type_once ();
		g_once_init_leave (&sound_pulse_audio_manager_type_id__volatile, sound_pulse_audio_manager_type_id);
	}
	return sound_pulse_audio_manager_type_id__volatile;
}

static void
_vala_sound_pulse_audio_manager_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	SoundPulseAudioManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
	switch (property_id) {
		case SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY:
		g_value_set_pointer (value, sound_pulse_audio_manager_get_context (self));
		break;
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY:
		g_value_set_object (value, sound_pulse_audio_manager_get_default_output (self));
		break;
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY:
		g_value_set_object (value, sound_pulse_audio_manager_get_default_input (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_sound_pulse_audio_manager_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	SoundPulseAudioManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
	switch (property_id) {
		case SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY:
		sound_pulse_audio_manager_set_context (self, g_value_get_pointer (value));
		break;
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY:
		sound_pulse_audio_manager_set_default_output (self, g_value_get_object (value));
		break;
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY:
		sound_pulse_audio_manager_set_default_input (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

